searchData={"items":[{"type":"module","doc":"Provides the core functions to retrieve and manage\nthe CLDR data that supports formatting and localisation.\n\nIt provides the core functions to access formatted\nCLDR data, set and retrieve a current locale and validate\ncertain core data types such as locales, currencies and\nterritories.","title":"Literature","ref":"Literature.html"},{"type":"function","doc":"See  Cldr.available_locale_name?/1 .","title":"Literature.available_locale_name?/1","ref":"Literature.html#available_locale_name?/1"},{"type":"function","doc":"","title":"Literature.build_params/1","ref":"Literature.html#build_params/1"},{"type":"function","doc":"Returns an `%Ecto.Changeset{}` for tracking author changes.","title":"Literature.change_author/2","ref":"Literature.html#change_author/2"},{"type":"function","doc":"iex> change_author(author)\n    %Ecto.Changeset{data: %Author{}}","title":"Examples - Literature.change_author/2","ref":"Literature.html#change_author/2-examples"},{"type":"function","doc":"Returns an `%Ecto.Changeset{}` for tracking post changes.","title":"Literature.change_post/2","ref":"Literature.html#change_post/2"},{"type":"function","doc":"iex> change_post(post)\n    %Ecto.Changeset{data: %Post{}}","title":"Examples - Literature.change_post/2","ref":"Literature.html#change_post/2-examples"},{"type":"function","doc":"Returns an `%Ecto.Changeset{}` for tracking publication changes.","title":"Literature.change_publication/2","ref":"Literature.html#change_publication/2"},{"type":"function","doc":"iex> change_publication(publication)\n    %Ecto.Changeset{data: %Publication{}}","title":"Examples - Literature.change_publication/2","ref":"Literature.html#change_publication/2-examples"},{"type":"function","doc":"Returns an `%Ecto.Changeset{}` for tracking redirect changes.","title":"Literature.change_redirect/2","ref":"Literature.html#change_redirect/2"},{"type":"function","doc":"iex> change_redirect(redirect)\n    %Ecto.Changeset{data: %Redirect{}}","title":"Examples - Literature.change_redirect/2","ref":"Literature.html#change_redirect/2-examples"},{"type":"function","doc":"Returns an `%Ecto.Changeset{}` for tracking tag changes.","title":"Literature.change_tag/2","ref":"Literature.html#change_tag/2"},{"type":"function","doc":"iex> change_tag(tag)\n    %Ecto.Changeset{data: %Tag{}}","title":"Examples - Literature.change_tag/2","ref":"Literature.html#change_tag/2-examples"},{"type":"function","doc":"Creates an author.","title":"Literature.create_author/1","ref":"Literature.html#create_author/1"},{"type":"function","doc":"iex> create_author(%{field: value})\n    {:ok, %Author{}}\n\n    iex> create_author(%{field: bad_value})\n    {:error, %Ecto.Changeset{}}","title":"Examples - Literature.create_author/1","ref":"Literature.html#create_author/1-examples"},{"type":"function","doc":"Creates a post.","title":"Literature.create_post/1","ref":"Literature.html#create_post/1"},{"type":"function","doc":"iex> create_post(%{field: value})\n    {:ok, %Post{}}\n\n    iex> create_post(%{field: bad_value})\n    {:error, %Ecto.Changeset{}}","title":"Examples - Literature.create_post/1","ref":"Literature.html#create_post/1-examples"},{"type":"function","doc":"Creates a publication.","title":"Literature.create_publication/1","ref":"Literature.html#create_publication/1"},{"type":"function","doc":"iex> create_publication(%{field: value})\n    {:ok, %Publication{}}\n\n    iex> create_publication(%{field: bad_value})\n    {:error, %Ecto.Changeset{}}","title":"Examples - Literature.create_publication/1","ref":"Literature.html#create_publication/1-examples"},{"type":"function","doc":"Creates a redirect.","title":"Literature.create_redirect/1","ref":"Literature.html#create_redirect/1"},{"type":"function","doc":"iex> create_redirect(%{field: value})\n    {:ok, %Redirect{}}\n\n    iex> create_redirect(%{field: bad_value})\n    {:error, %Ecto.Changeset{}}","title":"Examples - Literature.create_redirect/1","ref":"Literature.html#create_redirect/1-examples"},{"type":"function","doc":"Creates a tag.","title":"Literature.create_tag/1","ref":"Literature.html#create_tag/1"},{"type":"function","doc":"iex> create_tag(%{field: value})\n    {:ok, %Tag{}}\n\n    iex> create_tag(%{field: bad_value})\n    {:error, %Ecto.Changeset{}}","title":"Examples - Literature.create_tag/1","ref":"Literature.html#create_tag/1-examples"},{"type":"function","doc":"Returns the default `locale`.","title":"Literature.default_locale/0","ref":"Literature.html#default_locale/0"},{"type":"function","doc":"iex> Literature.default_locale()\n    %Cldr.LanguageTag{\n      backend: Literature,\n      canonical_locale_name: \"en-001\",\n      cldr_locale_name: :\"en-001\",\n      language_subtags: [],\n      extensions: %{},\n      gettext_locale_name: \"en\",\n      language: \"en\",\n      locale: %{},\n      private_use: [],\n      rbnf_locale_name: :en,\n      requested_locale_name: \"en-001\",\n      script: :Latn,\n      territory: :\"001\",\n      transform: %{},\n      language_variants: []\n    }","title":"Example - Literature.default_locale/0","ref":"Literature.html#default_locale/0-example"},{"type":"function","doc":"Returns the default territory when a locale\ndoes not specify one and none can be inferred.","title":"Literature.default_territory/0","ref":"Literature.html#default_territory/0"},{"type":"function","doc":"iex> Literature.default_territory()\n    :\"001\"","title":"Example - Literature.default_territory/0","ref":"Literature.html#default_territory/0-example"},{"type":"function","doc":"Deletes an author.","title":"Literature.delete_author/1","ref":"Literature.html#delete_author/1"},{"type":"function","doc":"iex> delete_author(author)\n    {:ok, %Author{}}\n\n    iex> delete_author(author)\n    {:error, %Ecto.Changeset{}}","title":"Examples - Literature.delete_author/1","ref":"Literature.html#delete_author/1-examples"},{"type":"function","doc":"Deletes a post.","title":"Literature.delete_post/1","ref":"Literature.html#delete_post/1"},{"type":"function","doc":"iex> delete_post(post)\n    {:ok, %Post{}}\n\n    iex> delete_post(post)\n    {:error, %Ecto.Changeset{}}","title":"Examples - Literature.delete_post/1","ref":"Literature.html#delete_post/1-examples"},{"type":"function","doc":"Deletes a publication.","title":"Literature.delete_publication/1","ref":"Literature.html#delete_publication/1"},{"type":"function","doc":"iex> delete_publication(publication)\n    {:ok, %Publication{}}\n\n    iex> delete_publication(publication)\n    {:error, %Ecto.Changeset{}}","title":"Examples - Literature.delete_publication/1","ref":"Literature.html#delete_publication/1-examples"},{"type":"function","doc":"Deletes a redirect.","title":"Literature.delete_redirect/1","ref":"Literature.html#delete_redirect/1"},{"type":"function","doc":"iex> delete_redirect(redirect)\n    {:ok, %Redirect{}}\n\n    iex> delete_redirect(redirect)\n    {:error, %Ecto.Changeset{}}","title":"Examples - Literature.delete_redirect/1","ref":"Literature.html#delete_redirect/1-examples"},{"type":"function","doc":"Deletes a tag.","title":"Literature.delete_tag/1","ref":"Literature.html#delete_tag/1"},{"type":"function","doc":"iex> delete_tag(tag)\n    {:ok, %Tag{}}\n\n    iex> delete_tag(tag)\n    {:error, %Ecto.Changeset{}}","title":"Examples - Literature.delete_tag/1","ref":"Literature.html#delete_tag/1-examples"},{"type":"function","doc":"Add locale-specific ellipsis to a string.","title":"Literature.ellipsis/2","ref":"Literature.html#ellipsis/2"},{"type":"function","doc":"* `string` is any `String.t` or a 2-element list\n  of `String.t` between which the ellipsis is inserted.\n\n* `backend` is any module that includes `use Cldr` and therefore\n  is a `Cldr` backend module.  The default is `Cldr.default_backend!/0`.\n  Note that `Cldr.default_backend!/0` will raise an exception if\n  no `:default_backend` is configured under the `:ex_cldr` key in\n  `config.exs`.\n\n* `options` is a keyword list of options","title":"Arguments - Literature.ellipsis/2","ref":"Literature.html#ellipsis/2-arguments"},{"type":"function","doc":"* `:locale` is any valid locale name returned by `Cldr.known_locale_names/1`.\n  The default is `Cldr.get_locale/0`.\n\n* `:location` determines where to place the ellipsis. The options are\n  `:after` (the default for a single string argument), `:between`\n  (the default and only valid location for an argument that is a list\n  of two strings) and `:before`.\n\n* `:format` formats based upon whether the ellipsis\n  is inserted between words or sentences. The valid options are\n  `:word` or `:sentence`. The default is `:sentence`.","title":"Options - Literature.ellipsis/2","ref":"Literature.html#ellipsis/2-options"},{"type":"function","doc":"iex> Literature.ellipsis(\"And furthermore\")\n    \"And furthermore…\"\n\n    iex> Literature.ellipsis([\"And furthermore\", \"there is much to be done\"], locale: :ja)\n    \"And furthermore…there is much to be done\"\n\n    iex> Literature.ellipsis(\"And furthermore\", format: :word)\n    \"And furthermore …\"\n\n    iex> Literature.ellipsis([\"And furthermore\", \"there is much to be done\"], locale: :ja, format: :word)\n    \"And furthermore … there is much to be done\"","title":"Examples - Literature.ellipsis/2","ref":"Literature.html#ellipsis/2-examples"},{"type":"function","doc":"Gets a single author.\n\nRaises `Ecto.NoResultsError` if the Author does not exist.","title":"Literature.get_author!/1","ref":"Literature.html#get_author!/1"},{"type":"function","doc":"iex> get_author!(123)\n    %Author{}\n\n    iex> get_author!(456)\n    ** (Ecto.NoResultsError)","title":"Examples - Literature.get_author!/1","ref":"Literature.html#get_author!/1-examples"},{"type":"function","doc":"Return the current locale to be used for `Cldr` functions that\ntake an optional locale parameter for which a locale is not supplied.","title":"Literature.get_locale/0","ref":"Literature.html#get_locale/0"},{"type":"function","doc":"iex> Literature.put_locale(\"pl\")\n    iex> Literature.get_locale()\n    %Cldr.LanguageTag{\n       backend: Elixir.Literature,\n       canonical_locale_name: \"pl\",\n       cldr_locale_name: :pl,\n       extensions: %{},\n       language: \"pl\",\n       locale: %{},\n       private_use: [],\n       rbnf_locale_name: :pl,\n       territory: :PL,\n       requested_locale_name: \"pl\",\n       script: :Latn,\n       transform: %{},\n       language_variants: []\n     }","title":"Example - Literature.get_locale/0","ref":"Literature.html#get_locale/0-example"},{"type":"function","doc":"Gets a single post.\n\nRaises `Ecto.NoResultsError` if the Post does not exist.","title":"Literature.get_post!/1","ref":"Literature.html#get_post!/1"},{"type":"function","doc":"iex> get_post!(123)\n    %Post{}\n\n    iex> get_post!(456)\n    ** (Ecto.NoResultsError)","title":"Examples - Literature.get_post!/1","ref":"Literature.html#get_post!/1-examples"},{"type":"function","doc":"Gets a single publication.\n\nRaises `Ecto.NoResultsError` if the Publication does not exist.","title":"Literature.get_publication!/1","ref":"Literature.html#get_publication!/1"},{"type":"function","doc":"iex> get_publication!(123)\n    %Publication{}\n\n    iex> get_publication!(456)\n    ** (Ecto.NoResultsError)","title":"Examples - Literature.get_publication!/1","ref":"Literature.html#get_publication!/1-examples"},{"type":"function","doc":"Gets a single redirect.\n\nRaises `Ecto.NoResultsError` if the Redirect does not exist.","title":"Literature.get_redirect!/1","ref":"Literature.html#get_redirect!/1"},{"type":"function","doc":"iex> get_redirect!(123)\n    %Redirect{}\n\n    iex> get_redirect!(456)\n    ** (Ecto.NoResultsError)","title":"Examples - Literature.get_redirect!/1","ref":"Literature.html#get_redirect!/1-examples"},{"type":"function","doc":"Gets a single tag.\n\nRaises `Ecto.NoResultsError` if the Tag does not exist.","title":"Literature.get_tag!/1","ref":"Literature.html#get_tag!/1"},{"type":"function","doc":"iex> get_tag!(123)\n    %Tag{}\n\n    iex> get_tag!(456)\n    ** (Ecto.NoResultsError)","title":"Examples - Literature.get_tag!/1","ref":"Literature.html#get_tag!/1-examples"},{"type":"function","doc":"See  Cldr.known_calendars/0 .","title":"Literature.known_calendars/0","ref":"Literature.html#known_calendars/0"},{"type":"function","doc":"See  Cldr.known_currencies/0 .","title":"Literature.known_currencies/0","ref":"Literature.html#known_currencies/0"},{"type":"function","doc":"Returns either the Gettext `locale_name` in Cldr format or\n`false` based upon whether the locale name is configured in\n`Gettext`.","title":"Literature.known_gettext_locale_name/1","ref":"Literature.html#known_gettext_locale_name/1"},{"type":"function","doc":"* `locale` is any valid locale name returned by\n  `Literature.known_gettext_locale_names/0`","title":"Arguments - Literature.known_gettext_locale_name/1","ref":"Literature.html#known_gettext_locale_name/1-arguments"},{"type":"function","doc":"iex> Literature.known_gettext_locale_name(\"en\")\n    \"en\"\n\n    iex> Literature.known_gettext_locale_name(\"en-SA\")\n    false","title":"Examples - Literature.known_gettext_locale_name/1","ref":"Literature.html#known_gettext_locale_name/1-examples"},{"type":"function","doc":"Returns a boolean indicating if the specified locale\nname is configured and available in Gettext.","title":"Literature.known_gettext_locale_name?/1","ref":"Literature.html#known_gettext_locale_name?/1"},{"type":"function","doc":"* `locale` is any valid locale name returned by\n  `Literature.known_locale_names/0`","title":"Arguments - Literature.known_gettext_locale_name?/1","ref":"Literature.html#known_gettext_locale_name?/1-arguments"},{"type":"function","doc":"iex> Literature.known_gettext_locale_name?(\"en\")\n    true\n\n    iex> Literature.known_gettext_locale_name?(\"!!\")\n    false","title":"Examples - Literature.known_gettext_locale_name?/1","ref":"Literature.html#known_gettext_locale_name?/1-examples"},{"type":"function","doc":"Returns a list of Gettext locale names but in CLDR format with\nunderscore replaced by hyphen in order to facilitate comparisons\nwith `Cldr` locale names.","title":"Literature.known_gettext_locale_names/0","ref":"Literature.html#known_gettext_locale_names/0"},{"type":"function","doc":"Returns either the `locale_name` or `false` based upon\nwhether the locale name is configured in `Cldr`.\n\nThis is helpful when building a list of `or` expressions\nto return the first known locale name from a list.","title":"Literature.known_locale_name/1","ref":"Literature.html#known_locale_name/1"},{"type":"function","doc":"* `locale` is any valid locale name returned by\n  `Literature.known_locale_names/0`","title":"Arguments - Literature.known_locale_name/1","ref":"Literature.html#known_locale_name/1-arguments"},{"type":"function","doc":"iex> Literature.known_locale_name(:\"en-AU\")\n    :\"en-AU\"\n\n    iex> Literature.known_locale_name(:\"en-SA\")\n    false","title":"Examples - Literature.known_locale_name/1","ref":"Literature.html#known_locale_name/1-examples"},{"type":"function","doc":"Returns a boolean indicating if the specified locale\nname is configured and available in Cldr.","title":"Literature.known_locale_name?/1","ref":"Literature.html#known_locale_name?/1"},{"type":"function","doc":"* `locale` is any valid locale name returned by `Literature.known_locale_names/0`","title":"Arguments - Literature.known_locale_name?/1","ref":"Literature.html#known_locale_name?/1-arguments"},{"type":"function","doc":"iex> Literature.known_locale_name?(:en)\n    true\n\n    iex> Literature.known_locale_name?(:\"!!\")\n    false","title":"Examples - Literature.known_locale_name?/1","ref":"Literature.html#known_locale_name?/1-examples"},{"type":"function","doc":"Returns a list of the known locale names.\n\nKnown locales are those locales which\nare the subset of all CLDR locales that\nhave been configured for use either\nin this module or in `Gettext`.","title":"Literature.known_locale_names/0","ref":"Literature.html#known_locale_names/0"},{"type":"function","doc":"Returns a list of atoms representing the number systems types known to `Cldr`.","title":"Literature.known_number_system_types/0","ref":"Literature.html#known_number_system_types/0"},{"type":"function","doc":"iex> Literature.known_number_system_types()\n    [:default, :finance, :native, :traditional]","title":"Example - Literature.known_number_system_types/0","ref":"Literature.html#known_number_system_types/0-example"},{"type":"function","doc":"See  Cldr.known_number_systems/0 .","title":"Literature.known_number_systems/0","ref":"Literature.html#known_number_systems/0"},{"type":"function","doc":"Returns either the RBNF `locale_name` or `false` based upon\nwhether the locale name is configured in `Cldr`\nand has RBNF rules defined.","title":"Literature.known_rbnf_locale_name/1","ref":"Literature.html#known_rbnf_locale_name/1"},{"type":"function","doc":"* `locale` is any valid locale name returned by\n  `Literature.known_locale_names/0`","title":"Arguments - Literature.known_rbnf_locale_name/1","ref":"Literature.html#known_rbnf_locale_name/1-arguments"},{"type":"function","doc":"iex> Literature.known_rbnf_locale_name(:en)\n    :en\n\n    iex> Literature.known_rbnf_locale_name(:\"en-SA\")\n    false","title":"Examples - Literature.known_rbnf_locale_name/1","ref":"Literature.html#known_rbnf_locale_name/1-examples"},{"type":"function","doc":"Returns a boolean indicating if the specified locale\nname is configured and available in Cldr and supports\nrules based number formats (RBNF).","title":"Literature.known_rbnf_locale_name?/1","ref":"Literature.html#known_rbnf_locale_name?/1"},{"type":"function","doc":"* `locale` is any valid locale name returned by `Literature.known_locale_names/0`","title":"Arguments - Literature.known_rbnf_locale_name?/1","ref":"Literature.html#known_rbnf_locale_name?/1-arguments"},{"type":"function","doc":"iex> Literature.known_rbnf_locale_name?(:en)\n    true\n\n    iex> Literature.known_rbnf_locale_name?(:\"!!\")\n    false","title":"Examples - Literature.known_rbnf_locale_name?/1","ref":"Literature.html#known_rbnf_locale_name?/1-examples"},{"type":"function","doc":"Returns a list of locale names which have rules-based number\nformats (RBNF).","title":"Literature.known_rbnf_locale_names/0","ref":"Literature.html#known_rbnf_locale_names/0"},{"type":"function","doc":"See  Cldr.known_territories/0 .","title":"Literature.known_territories/0","ref":"Literature.html#known_territories/0"},{"type":"function","doc":"Returns the list of authors.","title":"Literature.list_authors/1","ref":"Literature.html#list_authors/1"},{"type":"function","doc":"iex> list_authors()\n    [%Author{}, ...]","title":"Examples - Literature.list_authors/1","ref":"Literature.html#list_authors/1-examples"},{"type":"function","doc":"Returns the list of posts.","title":"Literature.list_posts/1","ref":"Literature.html#list_posts/1"},{"type":"function","doc":"iex> list_posts()\n    [%Post{}, ...]","title":"Examples - Literature.list_posts/1","ref":"Literature.html#list_posts/1-examples"},{"type":"function","doc":"Returns the list of publications.","title":"Literature.list_publications/1","ref":"Literature.html#list_publications/1"},{"type":"function","doc":"iex> list_publications()\n    [%Publication{}, ...]","title":"Examples - Literature.list_publications/1","ref":"Literature.html#list_publications/1-examples"},{"type":"function","doc":"Returns the list of redirects.","title":"Literature.list_redirects/1","ref":"Literature.html#list_redirects/1"},{"type":"function","doc":"iex> list_redirects()\n    [%Redirect{}, ...]","title":"Examples - Literature.list_redirects/1","ref":"Literature.html#list_redirects/1-examples"},{"type":"function","doc":"Returns the list of tags.","title":"Literature.list_tags/1","ref":"Literature.html#list_tags/1"},{"type":"function","doc":"iex> list_tags()\n    [%Tag{}, ...]","title":"Examples - Literature.list_tags/1","ref":"Literature.html#list_tags/1-examples"},{"type":"function","doc":"Normalizes a string by applying transliteration\nof common symbols in numbers, currencies and dates","title":"Literature.normalize_lenient_parse/3","ref":"Literature.html#normalize_lenient_parse/3"},{"type":"function","doc":"Returns the paginate list of authors.","title":"Literature.paginate_authors/1","ref":"Literature.html#paginate_authors/1"},{"type":"function","doc":"iex> paginate_authors()\n    %Literature.Pagination.Page{entries: [%Author{}, ...], ...}","title":"Examples - Literature.paginate_authors/1","ref":"Literature.html#paginate_authors/1-examples"},{"type":"function","doc":"Returns the paginate list of posts.","title":"Literature.paginate_posts/1","ref":"Literature.html#paginate_posts/1"},{"type":"function","doc":"iex> paginate_posts()\n    %Literature.Pagination.Page{entries: [%Post{}, ...], ...}","title":"Examples - Literature.paginate_posts/1","ref":"Literature.html#paginate_posts/1-examples"},{"type":"function","doc":"Returns the paginate list of redirects.","title":"Literature.paginate_redirects/1","ref":"Literature.html#paginate_redirects/1"},{"type":"function","doc":"iex> paginate_redirects()\n    %Literature.Pagination.Page{entries: [%Redirect{}, ...], ...}","title":"Examples - Literature.paginate_redirects/1","ref":"Literature.html#paginate_redirects/1-examples"},{"type":"function","doc":"Returns the paginate list of tags.","title":"Literature.paginate_tags/1","ref":"Literature.html#paginate_tags/1"},{"type":"function","doc":"iex> paginate_tags()\n    %Literature.Pagination.Page{entries: [%Tag{}, ...], ...}","title":"Examples - Literature.paginate_tags/1","ref":"Literature.html#paginate_tags/1-examples"},{"type":"function","doc":"","title":"Literature.preload_tag_posts_with_position/2","ref":"Literature.html#preload_tag_posts_with_position/2"},{"type":"function","doc":"Set the current process's Gettext locale from a\n`t:Cldr.LanguageTag`.","title":"Literature.put_gettext_locale/1","ref":"Literature.html#put_gettext_locale/1"},{"type":"function","doc":"* `locale` is a `Cldr.LanguageTag` struct returned by `Cldr.Locale.new!/2`.","title":"Arguments - Literature.put_gettext_locale/1","ref":"Literature.html#put_gettext_locale/1-arguments"},{"type":"function","doc":"* `{:ok, gettext_locale_name}` or\n\n* `{:error, {exception, reason}}`","title":"Returns - Literature.put_gettext_locale/1","ref":"Literature.html#put_gettext_locale/1-returns"},{"type":"function","doc":"1. If the `locale.gettext_locale_name` is `nil` then an error\n   is returned.\n\n2. The `gettext` locale for the `gettext_backend` configured for the\n   CLDR backend defined by the `t:Cldr.LanguageTag` is set.","title":"Behaviour - Literature.put_gettext_locale/1","ref":"Literature.html#put_gettext_locale/1-behaviour"},{"type":"function","doc":"iex> import Cldr.LanguageTag.Sigil\n    iex> Literature.put_gettext_locale(~l\"en\")\n    {:ok, \"en\"}\n\n    iex> import Cldr.LanguageTag.Sigil\n    iex> Literature.put_gettext_locale(~l\"de\")\n    {\n      :error,\n      {\n        Cldr.UnknownLocaleError,\n        \"Locale TestBackend.Cldr.Locale.new!(\\\"de-DE\\\") does not map to a known gettext locale name\"\n      }\n    }","title":"Examples - Literature.put_gettext_locale/1","ref":"Literature.html#put_gettext_locale/1-examples"},{"type":"function","doc":"Set the current locale to be used for `Cldr` functions that\ntake an optional locale parameter for which a locale is not supplied.","title":"Literature.put_locale/1","ref":"Literature.html#put_locale/1"},{"type":"function","doc":"* `locale` is any valid locale name returned by `Literature.known_locale_names/0`\n  or a `t:Cldr.LanguageTag` struct returned by `Literature.Locale.new!/1`\n\nSee [rfc5646](https://tools.ietf.org/html/rfc5646) for the specification\nof a language tag.","title":"Arguments - Literature.put_locale/1","ref":"Literature.html#put_locale/1-arguments"},{"type":"function","doc":"iex> Literature.put_locale(\"en\")\n    {:ok,\n     %Cldr.LanguageTag{\n       backend: Literature,\n       canonical_locale_name: \"en\",\n       cldr_locale_name: :en,\n       language_subtags: [],\n       extensions: %{},\n       gettext_locale_name: \"en\",\n       language: \"en\",\n       locale: %{},\n       private_use: [],\n       rbnf_locale_name: :en,\n       requested_locale_name: \"en\",\n       script: :Latn,\n       territory: :US,\n       transform: %{},\n       language_variants: []\n     }}\n\n    iex> Literature.put_locale(\"invalid-locale!\")\n    {:error, {Cldr.LanguageTag.ParseError,\n      \"Expected a BCP47 language tag. Could not parse the remaining \\\"!\\\" starting at position 15\"}}","title":"Examples - Literature.put_locale/1","ref":"Literature.html#put_locale/1-examples"},{"type":"function","doc":"Add locale-specific quotation marks around a string.","title":"Literature.quote/2","ref":"Literature.html#quote/2"},{"type":"function","doc":"* `string` is any valid Elixir string\n\n* `options` is a keyword list of options","title":"Arguments - Literature.quote/2","ref":"Literature.html#quote/2-arguments"},{"type":"function","doc":"* `locale` is any valid locale name returned by `Cldr.known_locale_names/1`.\n  The default is `Cldr.get_locale/0`.\n\n* `:prefer` is one of `:default` or `:variant` with a default of `:default`.\n  Some locales have alternative opening and closing quote marks and `:prefer`\n  allows selecting a variant should one exist.","title":"Options - Literature.quote/2","ref":"Literature.html#quote/2-options"},{"type":"function","doc":"iex> Literature.quote(\"Quoted String\")\n    \"“Quoted String”\"\n\n    iex> Literature.quote(\"Quoted String\", prefer: :variant)\n    \"‘Quoted String’\"\n\n    iex> Literature.quote(\"Quoted String\", locale: :ja)\n    \"「Quoted String」\"","title":"Examples - Literature.quote/2","ref":"Literature.html#quote/2-examples"},{"type":"function","doc":"","title":"Literature.sort_tag_posts/2","ref":"Literature.html#sort_tag_posts/2"},{"type":"function","doc":"Returns a list of the locales names that are configured,\nbut not known in CLDR.\n\nSince there is a compile-time exception raised if there are\nany unknown locales this function should always\nreturn an empty list.","title":"Literature.unknown_locale_names/0","ref":"Literature.html#unknown_locale_names/0"},{"type":"function","doc":"Updates an author.","title":"Literature.update_author/2","ref":"Literature.html#update_author/2"},{"type":"function","doc":"iex> update_author(author, %{field: new_value})\n    {:ok, %Author{}}\n\n    iex> update_author(author, %{field: bad_value})\n    {:error, %Ecto.Changeset{}}","title":"Examples - Literature.update_author/2","ref":"Literature.html#update_author/2-examples"},{"type":"function","doc":"Updates a post.","title":"Literature.update_post/2","ref":"Literature.html#update_post/2"},{"type":"function","doc":"iex> update_post(post, %{field: new_value})\n    {:ok, %Post{}}\n\n    iex> update_post(post, %{field: bad_value})\n    {:error, %Ecto.Changeset{}}","title":"Examples - Literature.update_post/2","ref":"Literature.html#update_post/2-examples"},{"type":"function","doc":"Updates a publication.","title":"Literature.update_publication/2","ref":"Literature.html#update_publication/2"},{"type":"function","doc":"iex> update_publication(publication, %{field: new_value})\n    {:ok, %Publication{}}\n\n    iex> update_publication(publication, %{field: bad_value})\n    {:error, %Ecto.Changeset{}}","title":"Examples - Literature.update_publication/2","ref":"Literature.html#update_publication/2-examples"},{"type":"function","doc":"Updates a redirect.","title":"Literature.update_redirect/2","ref":"Literature.html#update_redirect/2"},{"type":"function","doc":"iex> update_redirect(redirect, %{field: new_value})\n    {:ok, %Redirect{}}\n\n    iex> update_redirect(redirect, %{field: bad_value})\n    {:error, %Ecto.Changeset{}}","title":"Examples - Literature.update_redirect/2","ref":"Literature.html#update_redirect/2-examples"},{"type":"function","doc":"Updates a tag.","title":"Literature.update_tag/2","ref":"Literature.html#update_tag/2"},{"type":"function","doc":"iex> update_tag(tag, %{field: new_value})\n    {:ok, %Tag{}}\n\n    iex> update_tag(tag, %{field: bad_value})\n    {:error, %Ecto.Changeset{}}","title":"Examples - Literature.update_tag/2","ref":"Literature.html#update_tag/2-examples"},{"type":"function","doc":"See  Cldr.validate_calendar/1 .","title":"Literature.validate_calendar/1","ref":"Literature.html#validate_calendar/1"},{"type":"function","doc":"See  Cldr.validate_currency/1 .","title":"Literature.validate_currency/1","ref":"Literature.html#validate_currency/1"},{"type":"function","doc":"Normalise and validate a locale name.","title":"Literature.validate_locale/1","ref":"Literature.html#validate_locale/1"},{"type":"function","doc":"* `locale` is any valid locale name returned by `Literature.known_locale_names/0`\n  or a `Cldr.LanguageTag` struct returned by `Literature.Locale.new!/1`","title":"Arguments - Literature.validate_locale/1","ref":"Literature.html#validate_locale/1-arguments"},{"type":"function","doc":"* `{:ok, language_tag}`\n\n* `{:error, reason}`","title":"Returns - Literature.validate_locale/1","ref":"Literature.html#validate_locale/1-returns"},{"type":"function","doc":"See [rfc5646](https://tools.ietf.org/html/rfc5646) for the specification\nof a language tag.","title":"Notes - Literature.validate_locale/1","ref":"Literature.html#validate_locale/1-notes"},{"type":"function","doc":"iex> Literature.validate_locale(:en)\n    {:ok,\n    %Cldr.LanguageTag{\n      backend: Literature,\n      canonical_locale_name: \"en\",\n      cldr_locale_name: :en,\n      extensions: %{},\n      gettext_locale_name: \"en\",\n      language: \"en\",\n      locale: %{},\n      private_use: [],\n      rbnf_locale_name: :en,\n      requested_locale_name: \"en\",\n      script: :Latn,\n      territory: :US,\n      transform: %{},\n      language_variants: []\n    }}\n\n\n    iex> Literature.validate_locale Literature.default_locale()\n    {:ok,\n    %Cldr.LanguageTag{\n      backend: Literature,\n      canonical_locale_name: \"en-001\",\n      cldr_locale_name: :\"en-001\",\n      extensions: %{},\n      gettext_locale_name: \"en\",\n      language: \"en\",\n      locale: %{},\n      private_use: [],\n      rbnf_locale_name: :en,\n      requested_locale_name: \"en-001\",\n      script: :Latn,\n      territory: :\"001\",\n      transform: %{},\n      language_variants: []\n    }}\n\n    iex> Literature.validate_locale(\"zzz\")\n    {:error, {Cldr.InvalidLanguageError, \"The language \\\"zzz\\\" is invalid\"}}","title":"Examples - Literature.validate_locale/1","ref":"Literature.html#validate_locale/1-examples"},{"type":"function","doc":"See  Cldr.validate_number_system/1 .","title":"Literature.validate_number_system/1","ref":"Literature.html#validate_number_system/1"},{"type":"function","doc":"Normalise and validate a number system type.","title":"Literature.validate_number_system_type/1","ref":"Literature.html#validate_number_system_type/1"},{"type":"function","doc":"* `number_system_type` is any number system type returned by\n  `Cldr.known_number_system_types/1`","title":"Arguments - Literature.validate_number_system_type/1","ref":"Literature.html#validate_number_system_type/1-arguments"},{"type":"function","doc":"* `{:ok, normalized_number_system_type}` or\n\n* `{:error, {exception, message}}`","title":"Returns - Literature.validate_number_system_type/1","ref":"Literature.html#validate_number_system_type/1-returns"},{"type":"function","doc":"iex> Literature.validate_number_system_type(:default)\n    {:ok, :default}\n\n    iex> Literature.validate_number_system_type(:traditional)\n    {:ok, :traditional}\n\n    iex> Literature.validate_number_system_type(:latn)\n    {\n      :error,\n      {Cldr.UnknownNumberSystemTypeError, \"The number system type :latn is unknown\"}\n    }\n\n    iex> Literature.validate_number_system_type(\"bork\")\n    {\n      :error,\n      {Cldr.UnknownNumberSystemTypeError, \"The number system type \\\"bork\\\" is invalid\"}\n    }","title":"Examples - Literature.validate_number_system_type/1","ref":"Literature.html#validate_number_system_type/1-examples"},{"type":"function","doc":"","title":"Literature.validate_params/1","ref":"Literature.html#validate_params/1"},{"type":"function","doc":"See  Cldr.validate_territory/1 .","title":"Literature.validate_territory/1","ref":"Literature.html#validate_territory/1"},{"type":"function","doc":"Execute a function with a locale ensuring that the\ncurrent locale is restored after the function.","title":"Literature.with_locale/2","ref":"Literature.html#with_locale/2"},{"type":"function","doc":"* `locale` is any valid locale name returned by `Cldr.known_locale_names/1`.\n\n* `fun` is any 0-arity function or function capture.","title":"Arguments - Literature.with_locale/2","ref":"Literature.html#with_locale/2-arguments"},{"type":"function","doc":"* The value returned by the function `fun/0` or\n\n* `{:error, {exception, reason}}` if the locale is invalid or\n\n* raises an exception if the current locale cannot be\n  identified.","title":"Returns - Literature.with_locale/2","ref":"Literature.html#with_locale/2-returns"},{"type":"module","doc":"Parses HTTP `Accept-Language` header values as defined in\n[rfc2616](https://www.w3.org/Protocols/rfc2616/rfc2616-sec14.html#sec14.4).\n\nThe Accept-Language request-header field is similar to Accept, but restricts\nthe set of natural languages that are preferred as a response to the request.\nLanguage tags function are provided in `Cldr.LanguageTag`.\n\nThe format of an `Accept-Language` header is as follows in `ABNF` format:\n\n       Accept-Language = \"Accept-Language\" \":\"\n                         1#( language-range [ \";\" \"q\" \"=\" qvalue ] )\n       language-range  = ( ( 1*8ALPHA *( \"-\" 1*8ALPHA ) ) | \"*\" )\n\nEach language-range MAY be given an associated quality value which represents an\nestimate of the user's preference for the languages specified by that range. The\nquality value defaults to \"q=1\". For example,\n\n       Accept-Language: da, en-gb;q=0.8, en;q=0.7\n\nwould mean: \"I prefer Danish, but will accept British English and other types of English.\"","title":"Literature.AcceptLanguage","ref":"Literature.AcceptLanguage.html"},{"type":"function","doc":"Parse an `Accept-Language` string and return the best match for\na configured `Cldr` locale.","title":"Literature.AcceptLanguage.best_match/1","ref":"Literature.AcceptLanguage.html#best_match/1"},{"type":"function","doc":"* `accept_language` is a string representing an accept language header","title":"Arguments - Literature.AcceptLanguage.best_match/1","ref":"Literature.AcceptLanguage.html#best_match/1-arguments"},{"type":"function","doc":"* `{:ok, language_tag}` or\n\n* `{:error, reason}`","title":"Returns - Literature.AcceptLanguage.best_match/1","ref":"Literature.AcceptLanguage.html#best_match/1-returns"},{"type":"function","doc":"iex> Literature.AcceptLanguage.best_match(\"da;q=0.1,zh-TW;q=0.3\", TestBackend.Cldr)\n    {:ok,\n     %Cldr.LanguageTag{\n       backend: TestBackend.Cldr,\n       canonical_locale_name: \"zh-TW\",\n       cldr_locale_name: :\"zh-Hant\",\n       language_subtags: [],\n       extensions: %{},\n       gettext_locale_name: nil,\n       language: \"zh\",\n       locale: %{},\n       private_use: [],\n       rbnf_locale_name: :\"zh-Hant\",\n       requested_locale_name: \"zh-TW\",\n       script: :Hant,\n       territory: :TW,\n       transform: %{},\n       language_variants: []\n     }}\n\n    iex> Literature.AcceptLanguage.best_match(\"da;q=0.1,zh-TW;q=0.3\", TestBackend.Cldr)\n    {:ok,\n     %Cldr.LanguageTag{\n       backend: TestBackend.Cldr,\n       canonical_locale_name: \"zh-TW\",\n       cldr_locale_name: :\"zh-Hant\",\n       language_subtags: [],\n       extensions: %{},\n       gettext_locale_name: nil,\n       language: \"zh\",\n       locale: %{},\n       private_use: [],\n       rbnf_locale_name: :\"zh-Hant\",\n       requested_locale_name: \"zh-TW\",\n       script: :Hant,\n       territory: :TW,\n       transform: %{},\n       language_variants: []\n     }}\n\n    iex> Literature.AcceptLanguage.best_match(\"xx,yy;q=0.3\")\n    {:error,\n     {Cldr.NoMatchingLocale,\n      \"No configured locale could be matched to \\\"xx,yy;q=0.3\\\"\"}}\n\n    iex> Literature.AcceptLanguage.best_match(\"invalid_tag\")\n    {:error, {Cldr.LanguageTag.ParseError,\n      \"Expected a BCP47 language tag. Could not parse the remaining \\\"g\\\" starting at position 11\"}}","title":"Examples - Literature.AcceptLanguage.best_match/1","ref":"Literature.AcceptLanguage.html#best_match/1-examples"},{"type":"function","doc":"Parses an `Accept-Language` header value in its string\nor tokenized form to return a tuple of the form\n`{:ok, [{quality, %Cldr.LanguageTag{}}, ...]}` sorted by quality.","title":"Literature.AcceptLanguage.parse/1","ref":"Literature.AcceptLanguage.html#parse/1"},{"type":"function","doc":"* `accept-language` is any string in the format defined by\n  [rfc2616](https://www.w3.org/Protocols/rfc2616/rfc2616-sec14.html#sec14.4)\n\n* `backend` is any module that includes `use Cldr` and therefore\n  is a `Cldr` backend module","title":"Arguments - Literature.AcceptLanguage.parse/1","ref":"Literature.AcceptLanguage.html#parse/1-arguments"},{"type":"function","doc":"* `{:ok, [{quality, language_tag}, ...]}` or\n\n* `{:error, {Cldr.AcceptLanguageError, String.t}}`\n\nIf at least one valid language tag is found but errors are also\ndetected on one more more tags, an `{ok, list}` tuple is returned\nwith an error tuple for each invalid tag added at the end of the list.","title":"Returns - Literature.AcceptLanguage.parse/1","ref":"Literature.AcceptLanguage.html#parse/1-returns"},{"type":"function","doc":"iex> Cldr.AcceptLanguage.parse(\"da,zh-TW;q=0.3\", TestBackend.Cldr)\n    {:ok,\n     [\n       {1.0,\n        %Cldr.LanguageTag{\n          backend: TestBackend.Cldr,\n          canonical_locale_name: \"da\",\n          cldr_locale_name: :da,\n          language_subtags: [],\n          extensions: %{},\n          gettext_locale_name: nil,\n          language: \"da\",\n          locale: %{},\n          private_use: [],\n          rbnf_locale_name: :da,\n          requested_locale_name: \"da\",\n          script: :Latn,\n          territory: :DK,\n          transform: %{},\n          language_variants: []\n        }},\n       {0.3,\n        %Cldr.LanguageTag{\n          backend: TestBackend.Cldr,\n          canonical_locale_name: \"zh-TW\",\n          cldr_locale_name: :\"zh-Hant\",\n          language_subtags: [],\n          extensions: %{},\n          gettext_locale_name: nil,\n          language: \"zh\",\n          locale: %{},\n          private_use: [],\n          rbnf_locale_name: :\"zh-Hant\",\n          requested_locale_name: \"zh-TW\",\n          script: :Hant,\n          territory: :TW,\n          transform: %{},\n          language_variants: []\n        }}\n     ]}\n\n    iex> Literature.AcceptLanguage.parse(\"invalid_tag\")\n    {:error,\n     {Cldr.LanguageTag.ParseError,\n      \"Expected a BCP47 language tag. Could not parse the remaining \\\"g\\\" starting at position 11\"}}\n\n    iex> Literature.AcceptLanguage.parse(\"da,zh-TW;q=0.3,invalid_tag\")\n    {:ok,\n     [\n       {1.0,\n        %Cldr.LanguageTag{\n          backend: TestBackend.Cldr,\n          canonical_locale_name: \"da\",\n          cldr_locale_name: :da,\n          language_subtags: [],\n          extensions: %{},\n          gettext_locale_name: nil,\n          language: \"da\",\n          locale: %{},\n          private_use: [],\n          rbnf_locale_name: :da,\n          requested_locale_name: \"da\",\n          script: :Latn,\n          territory: :DK,\n          transform: %{},\n          language_variants: []\n        }},\n       {0.3,\n        %Cldr.LanguageTag{\n          backend: TestBackend.Cldr,\n          canonical_locale_name: \"zh-TW\",\n          cldr_locale_name: :\"zh-Hant\",\n          language_subtags: [],\n          extensions: %{},\n          gettext_locale_name: nil,\n          language: \"zh\",\n          locale: %{},\n          private_use: [],\n          rbnf_locale_name: :\"zh-Hant\",\n          requested_locale_name: \"zh-TW\",\n          script: :Hant,\n          territory: :TW,\n          transform: %{},\n          language_variants: []\n        }},\n       {:error,\n        {Cldr.LanguageTag.ParseError,\n         \"Expected a BCP47 language tag. Could not parse the remaining \\\"g\\\" starting at position 11\"}}\n     ]}","title":"Example - Literature.AcceptLanguage.parse/1","ref":"Literature.AcceptLanguage.html#parse/1-example"},{"type":"function","doc":"Parses an `Accept-Language` header value in its string\nor tokenized form to produce a list of tuples of the form\n`[{quality, %Cldr.LanguageTag{}}, ...]` sorted by quality\nin descending order.","title":"Literature.AcceptLanguage.parse!/1","ref":"Literature.AcceptLanguage.html#parse!/1"},{"type":"function","doc":"* `accept-language` is any string in the format defined by [rfc2616](https://www.w3.org/Protocols/rfc2616/rfc2616-sec14.html#sec14.4)","title":"Arguments - Literature.AcceptLanguage.parse!/1","ref":"Literature.AcceptLanguage.html#parse!/1-arguments"},{"type":"function","doc":"* `{:ok, [{quality, language_tag}, ...]}` or\n\n* raises a `Cldr.AcceptLanguageError` exception\n\nIf at least one valid language tag is found but errors are also\ndetected on one more more tags, an `{ok, list}` tuple is returned\nwith an error tuple for each invalid tag added at the end of the list.","title":"Returns - Literature.AcceptLanguage.parse!/1","ref":"Literature.AcceptLanguage.html#parse!/1-returns"},{"type":"function","doc":"iex> Literature.AcceptLanguage.parse!(\"da,zh-TW;q=0.3\")\n    [\n      {1.0,\n       %Cldr.LanguageTag{\n         backend: TestBackend.Cldr,\n         canonical_locale_name: \"da\",\n         cldr_locale_name: :da,\n         language_subtags: [],\n         extensions: %{},\n         gettext_locale_name: nil,\n         language: \"da\",\n         locale: %{},\n         private_use: [],\n         rbnf_locale_name: :da,\n         requested_locale_name: \"da\",\n         script: :Latn,\n         territory: :DK,\n         transform: %{},\n         language_variants: []\n       }},\n      {0.3,\n       %Cldr.LanguageTag{\n         backend: TestBackend.Cldr,\n         canonical_locale_name: \"zh-TW\",\n         cldr_locale_name: :\"zh-Hant\",\n         language_subtags: [],\n         extensions: %{},\n         gettext_locale_name: nil,\n         language: \"zh\",\n         locale: %{},\n         private_use: [],\n         rbnf_locale_name: :\"zh-Hant\",\n         requested_locale_name: \"zh-TW\",\n         script: :Hant,\n         territory: :TW,\n         transform: %{},\n         language_variants: []\n       }}\n    ]\n\n    Literature.AcceptLanguage.parse! \"invalid_tag\"\n    ** (Cldr.AcceptLanguageError) \"Expected a BCP47 language tag. Could not parse the remaining \"g\" starting at position 11\n        (ex_cldr) lib/cldr/accept_language.ex:304: Cldr.AcceptLanguage.parse!/1\n\n    iex> Literature.AcceptLanguage.parse!(\"da,zh-TW;q=0.3,invalid_tag\")\n    [\n      {1.0,\n       %Cldr.LanguageTag{\n         backend: TestBackend.Cldr,\n         canonical_locale_name: \"da\",\n         cldr_locale_name: :da,\n         language_subtags: [],\n         extensions: %{},\n         gettext_locale_name: nil,\n         language: \"da\",\n         locale: %{},\n         private_use: [],\n         rbnf_locale_name: :da,\n         requested_locale_name: \"da\",\n         script: :Latn,\n         territory: :DK,\n         transform: %{},\n         language_variants: []\n       }},\n      {0.3,\n       %Cldr.LanguageTag{\n         backend: TestBackend.Cldr,\n         canonical_locale_name: \"zh-TW\",\n         cldr_locale_name: :\"zh-Hant\",\n         language_subtags: [],\n         extensions: %{},\n         gettext_locale_name: nil,\n         language: \"zh\",\n         locale: %{},\n         private_use: [],\n         rbnf_locale_name: :\"zh-Hant\",\n         requested_locale_name: \"zh-TW\",\n         script: :Hant,\n         territory: :TW,\n         transform: %{},\n         language_variants: []\n       }},\n      {:error,\n       {Cldr.LanguageTag.ParseError,\n        \"Expected a BCP47 language tag. Could not parse the remaining \\\"g\\\" starting at position 11\"}}\n    ]","title":"Example - Literature.AcceptLanguage.parse!/1","ref":"Literature.AcceptLanguage.html#parse!/1-example"},{"type":"module","doc":"Literature Cloudflare","title":"Literature.Cloudflare","ref":"Literature.Cloudflare.html"},{"type":"function","doc":"Purge cloudflare files.","title":"Literature.Cloudflare.purge_cloudflare_files/2","ref":"Literature.Cloudflare.html#purge_cloudflare_files/2"},{"type":"module","doc":"Returns:\n\n  * `{:ok, stored_file_absolute_path}` if everything were ok.\n  * `{:error, :file_size_is_too_big}` if file size exceeds `max_file_size`\n  * `{:error, :download_failure}` if host isn't reachable\n  * `{:error, :eexist}` if file exists already\n\nOptions:\n\n  * `max_file_size` - max available file size for downloading (in bytes). Default is `1024 * 1024 * 1000` (1GB)\n  * `path` - absolute file path for the saved file. Default is `pwd <> requested file name`","title":"Literature.DownloadHelpers","ref":"Literature.DownloadHelpers.html"},{"type":"module","doc":"iex> Literature.DownloadHelpers.download_image(\"http://speedtest.ftp.otenet.gr/files/test100k.db\")\n    {:ok, \"/absolute/path/to/test_100k.db\"}\n\n    iex> Literature.DownloadHelpers.download_image(\"http://speedtest.ftp.otenet.gr/files/test100k.db\", [max_file_size: 99 * 1000])\n    {:error, :file_size_is_too_big}\n\n    iex> Literature.DownloadHelpers.download_image(\"http://speedtest.ftp.otenet.gr/files/test100k.db\", [path: \"/custom/absolute/file/path.db\"])\n    {:ok, \"/custom/absolute/file/path.db\"}","title":"Examples - Literature.DownloadHelpers","ref":"Literature.DownloadHelpers.html#module-examples"},{"type":"function","doc":"","title":"Literature.DownloadHelpers.download_image/2","ref":"Literature.DownloadHelpers.html#download_image/2"},{"type":"module","doc":"","title":"Literature.Language","ref":"Literature.Language.html"},{"type":"function","doc":"Return all the languages' iso-codes available for a given locale.\nDefaults to the current locale.","title":"Literature.Language.available_languages/1","ref":"Literature.Language.html#available_languages/1"},{"type":"function","doc":"> Literature.Language.Language.available_languages(:en)\n    [\"aa\", \"ab\", \"ace\", \"ach\", \"ada\", \"ady\", \"ae\", \"aeb\", \"af\", \"afh\", \"agq\", \"ain\",\n    \"ak\", \"akk\", \"akz\", \"ale\", \"aln\", \"alt\", \"am\", \"an\", \"ang\", \"anp\", \"ar\",\n    \"ar-001\", \"arc\", \"arn\", \"aro\", \"arp\", \"arq\", \"ars\", \"arw\", \"ary\", \"arz\", \"as\",\n    \"asa\", \"ase\", \"ast\", \"av\", \"avk\", \"awa\", \"ay\", \"az\", \"ba\", \"bal\", \"ban\", \"bar\",\n    \"bas\", \"bax\", \"bbc\", \"bbj\", ...]","title":"Example - Literature.Language.available_languages/1","ref":"Literature.Language.html#available_languages/1-example"},{"type":"function","doc":"Return a map of iso-code keyed maps of language names in any available\nformats for the given locale.\nDefaults to the current locale.","title":"Literature.Language.known_languages/1","ref":"Literature.Language.html#known_languages/1"},{"type":"function","doc":"> Literature.Language.Language.known_languages(:en)\n    %{\"bez\" => %{standard: \"Bena\"}, \"lo\" => %{standard: \"Lao\"},\n    \"kha\" => %{standard: \"Khasi\"}, \"eo\" => %{standard: \"Esperanto\"},\n    \"rm\" => %{standard: \"Romansh\"}, \"ja\" => %{standard: \"Japanese\"},\n    \"sw-CD\" => %{standard: \"Congo Swahili\"},\n    \"pdc\" => %{standard: \"Pennsylvania German\"}, \"om\" => %{standard: \"Oromo\"},\n    \"jut\" => %{standard: \"Jutish\"}, \"lij\" => %{standard: \"Ligurian\"},\n    \"kut\" => %{standard: \"Kutenai\"}, \"vep\" => %{standard: \"Veps\"},\n    \"yao\" => %{standard: \"Yao\"}, \"gez\" => %{standard: \"Geez\"},\n    \"cr\" => %{standard: \"Cree\"}, \"ne\" => %{standard: \"Nepali\"},\n    \"zbl\" => %{standard: \"Blissymbols\"}, \"ae\" => %{standard: \"Avestan\"},\n    \"rof\" => %{standard: \"Rombo\"}, \"tkl\" => %{standard: \"Tokelau\"},\n    \"rgn\" => %{standard: \"Romagnol\"}, \"el\" => %{standard: \"Greek\"},\n    \"myv\" => %{standard: \"Erzya\"}, \"smj\" => %{standard: \"Lule Sami\"},\n    \"fo\" => %{standard: \"Faroese\"}, \"ii\" => %{standard: \"Sichuan Yi\"},\n    \"bum\" => %{standard: \"Bulu\"}, \"za\" => %{standard: \"Zhuang\"},\n    \"raj\" => %{standard: \"Rajasthani\"}, \"mrj\" => %{standard: \"Western Mari\"},\n    \"stq\" => %{standard: \"Saterland Frisian\"}, \"hu\" => %{standard: \"Hungarian\"},\n    \"mga\" => %{standard: \"Middle Irish\"}, \"bej\" => %{standard: \"Beja\"},\n    \"yue\" => %{standard: \"Cantonese\"}, \"xog\" => %{standard: \"Soga\"},\n    \"ttt\" => %{standard: \"Muslim Tat\"}, \"uga\" => %{standard: \"Ugaritic\"},\n    \"rup\" => %{standard: \"Aromanian\"},\n    \"crs\" => %{standard: \"Seselwa Creole French\"}, \"oc\" => %{standard: \"Occitan\"},\n    \"chp\" => %{standard: \"Chipewyan\"}, \"zen\" => %{standard: \"Zenaga\"},\n    \"kmb\" => %{standard: \"Kimbundu\"}, \"nr\" => %{standard: \"South Ndebele\"},\n    \"tiv\" => %{standard: \"Tiv\"}, \"aln\" => %{standard: \"Gheg Albanian\"},\n    \"sh\" => %{standard: \"Serbo-Croatian\"}, \"fil\" => %{...}, ...}","title":"Example - Literature.Language.known_languages/1","ref":"Literature.Language.html#known_languages/1-example"},{"type":"type","doc":"","title":"Literature.Language.styles/0","ref":"Literature.Language.html#t:styles/0"},{"type":"function","doc":"Try to translate the given language iso code or language tag.","title":"Literature.Language.to_string/2","ref":"Literature.Language.html#to_string/2"},{"type":"function","doc":"iex> Literature.Language.Language.to_string(\"eo\")\n    {:ok, \"Esperanto\"}","title":"Example - Literature.Language.to_string/2","ref":"Literature.Language.html#to_string/2-example"},{"type":"module","doc":"Backend module that provides functions\nto define new locales and display human-readable\nlocale names for presentation purposes.","title":"Literature.Locale","ref":"Literature.Locale.html"},{"type":"function","doc":"Returns the list of fallback locale names, starting\nwith the provided locale name.\n\nFallbacks are a list of locate names which can\nbe used to resolve translation or other localization\ndata if such localised data does not exist for\nthis specific locale..","title":"Literature.Locale.fallback_locale_names/1","ref":"Literature.Locale.html#fallback_locale_names/1"},{"type":"function","doc":"* `locale_name` is any locale name returned by\n  `Literature.known_locale_names/0`","title":"Arguments - Literature.Locale.fallback_locale_names/1","ref":"Literature.Locale.html#fallback_locale_names/1-arguments"},{"type":"function","doc":"* `{:ok, list_of_locale_names}` or\n\n* `{:error, {exception, reason}}`","title":"Returns - Literature.Locale.fallback_locale_names/1","ref":"Literature.Locale.html#fallback_locale_names/1-returns"},{"type":"function","doc":"iex> Literature.Locale.fallback_locale_names(:\"fr-CA\")\n    {:ok, [:\"fr-CA\", :fr, :und]}\n\n    # Fallbacks are typically formed by progressively\n    # stripping variant, territory and script from the\n    # given locale name. But not always - there are\n    # certain fallbacks that take a different path.\n\n    iex> Literature.Locale.fallback_locale_names(:nb)\n    {:ok, [:nb, :no, :und]}","title":"Examples - Literature.Locale.fallback_locale_names/1","ref":"Literature.Locale.html#fallback_locale_names/1-examples"},{"type":"function","doc":"Returns the list of fallback locales, starting\nwith the provided locale name.\n\nFallbacks are a list of locate names which can\nbe used to resolve translation or other localization\ndata if such localised data does not exist for\nthis specific locale.","title":"Literature.Locale.fallback_locales/1","ref":"Literature.Locale.html#fallback_locales/1"},{"type":"function","doc":"* `locale_name` is any locale name returned by\n  `Literature.known_locale_names/0`","title":"Arguments - Literature.Locale.fallback_locales/1","ref":"Literature.Locale.html#fallback_locales/1-arguments"},{"type":"function","doc":"* `{:ok, list_of_locales}` or\n\n* `{:error, {exception, reason}}`","title":"Returns - Literature.Locale.fallback_locales/1","ref":"Literature.Locale.html#fallback_locales/1-returns"},{"type":"function","doc":"Literature.Locale.fallback_locales(:\"fr-CA\")\n    => {:ok,\n         [#Cldr.LanguageTag , #Cldr.LanguageTag ,\n          #Cldr.LanguageTag ]}\n\n    # Fallbacks are typically formed by progressively\n    # stripping variant, territory and script from the\n    # given locale name. But not always - there are\n    # certain fallbacks that take a different path.\n\n    Literature.Locale.fallback_locales(:nb))\n    => {:ok,\n         [#Cldr.LanguageTag , #Cldr.LanguageTag ,\n          #Cldr.LanguageTag ]}","title":"Examples - Literature.Locale.fallback_locales/1","ref":"Literature.Locale.html#fallback_locales/1-examples"},{"type":"function","doc":"Returns the \"best fit\" locale for a given territory.\n\nUsing the population percentage data from CLDR, the\nlanguage most commonly spoken in the given territory\nis used to form a locale name which is then validated\nagainst the given backend.\n\nFirst a territory-specific locale is validated and if\nthat fails, the base language only is validate.\n\nFor example, if the territory is `AU` then then the\nlanguage most spoken is \"en\". First, the locale \"en-AU\"\nis validated and if that fails, \"en\" is validated.","title":"Literature.Locale.locale_for_territory/1","ref":"Literature.Locale.html#locale_for_territory/1"},{"type":"function","doc":"* `territory` is any ISO 3166 Alpha-2 territory\n  code that can be validated by `Cldr.validate_territory/1`","title":"Arguments - Literature.Locale.locale_for_territory/1","ref":"Literature.Locale.html#locale_for_territory/1-arguments"},{"type":"function","doc":"* `{:ok, language_tag}` or\n\n* `{:error, {exception, reason}}`","title":"Returns - Literature.Locale.locale_for_territory/1","ref":"Literature.Locale.html#locale_for_territory/1-returns"},{"type":"function","doc":"iex> Literature.Locale.locale_for_territory(:AU)\n  Elixir.Literature.validate_locale(:\"en-AU\")\n\n  iex> Literature.Locale.locale_for_territory(:US)\n  Elixir.Literature.validate_locale(:\"en-US\")\n\n  iex> Literature.Locale.locale_for_territory(:ZZ)\n  {:error, {Cldr.UnknownTerritoryError, \"The territory :ZZ is unknown\"}}","title":"Examples - Literature.Locale.locale_for_territory/1","ref":"Literature.Locale.html#locale_for_territory/1-examples"},{"type":"function","doc":"Returns a \"best fit\" locale for a host name.","title":"Literature.Locale.locale_from_host/2","ref":"Literature.Locale.html#locale_from_host/2"},{"type":"function","doc":"* `host` is any valid host name\n\n* `options` is a keyword list of options. The default\n  is `[]`.","title":"Arguments - Literature.Locale.locale_from_host/2","ref":"Literature.Locale.html#locale_from_host/2-arguments"},{"type":"function","doc":"* `:tlds` is a list of territory codes as upper-cased\n  atoms that are to be considered as top-level domains.\n  See `Cldr.Locale.locale_from_host/2` for the default\n  list.","title":"Options - Literature.Locale.locale_from_host/2","ref":"Literature.Locale.html#locale_from_host/2-options"},{"type":"function","doc":"* `{:ok, langauge_tag}` or\n\n* `{:error, {exception, reason}}`","title":"Returns - Literature.Locale.locale_from_host/2","ref":"Literature.Locale.html#locale_from_host/2-returns"},{"type":"function","doc":"Certain top-level domains have become associated with content\nunderlated to the territory for who the domain is registered.\nTherefore Google (and perhaps others) do not associate these\nTLDs as belonging to the territory but rather are considered\ngeneric top-level domain names.","title":"Notes - Literature.Locale.locale_from_host/2","ref":"Literature.Locale.html#locale_from_host/2-notes"},{"type":"function","doc":"iex> Literature.Locale.locale_from_host \"a.b.com.au\"\n    Elixir.Literature.validate_locale(:\"en-AU\")\n\n    iex> Literature.Locale.locale_from_host(\"a.b.com.tv\")\n    {:error,\n     {Cldr.UnknownLocaleError, \"No locale was identified for territory \\\"tv\\\"\"}}\n\n    iex> Literature.Locale.locale_from_host(\"a.b.com\")\n    {:error,\n     {Cldr.UnknownLocaleError, \"No locale was identified for territory \\\"com\\\"\"}}","title":"Examples - Literature.Locale.locale_from_host/2","ref":"Literature.Locale.html#locale_from_host/2-examples"},{"type":"function","doc":"","title":"Literature.Locale.new/1","ref":"Literature.Locale.html#new/1"},{"type":"function","doc":"","title":"Literature.Locale.new!/1","ref":"Literature.Locale.html#new!/1"},{"type":"function","doc":"Returns the script direction for a locale.","title":"Literature.Locale.script_direction_from_locale/1","ref":"Literature.Locale.html#script_direction_from_locale/1"},{"type":"function","doc":"* `language_tag` is any language tag returned by `Cldr.Locale.new/2`\n  or any `locale_name` returned by `Cldr.known_locale_names/1`.","title":"Arguments - Literature.Locale.script_direction_from_locale/1","ref":"Literature.Locale.html#script_direction_from_locale/1-arguments"},{"type":"function","doc":"* The script direction which is either `:ltr` (for left-to-right\n  scripts) or `:rtl` (for right-to-left scripts).","title":"Returns - Literature.Locale.script_direction_from_locale/1","ref":"Literature.Locale.html#script_direction_from_locale/1-returns"},{"type":"function","doc":"iex> Literature.Locale.script_direction_from_locale \"en-US\"\n    :ltr\n\n    iex> Literature.Locale.script_direction_from_locale :ar\n    :rtl","title":"Examples - Literature.Locale.script_direction_from_locale/1","ref":"Literature.Locale.html#script_direction_from_locale/1-examples"},{"type":"function","doc":"Returns the last segment of a host that might\nbe a territory.","title":"Literature.Locale.territory_from_host/1","ref":"Literature.Locale.html#territory_from_host/1"},{"type":"function","doc":"* `host` is any valid host name","title":"Arguments - Literature.Locale.territory_from_host/1","ref":"Literature.Locale.html#territory_from_host/1-arguments"},{"type":"function","doc":"* `{:ok, territory}` or\n\n* `{:error, {exception, reason}}`","title":"Returns - Literature.Locale.territory_from_host/1","ref":"Literature.Locale.html#territory_from_host/1-returns"},{"type":"function","doc":"iex> Cldr.Locale.territory_from_host(\"a.b.com.au\")\n    {:ok, :AU}\n\n    iex> Cldr.Locale.territory_from_host(\"a.b.com\")\n    {:error,\n     {Cldr.UnknownLocaleError, \"No locale was identified for territory \\\"com\\\"\"}}","title":"Examples - Literature.Locale.territory_from_host/1","ref":"Literature.Locale.html#territory_from_host/1-examples"},{"type":"function","doc":"Returns the territory from a language tag or\nlocale name.","title":"Literature.Locale.territory_from_locale/1","ref":"Literature.Locale.html#territory_from_locale/1"},{"type":"function","doc":"* `locale` is any language tag returned by\n  `Literature.Locale.new/1`\n  or a locale name in the list returned by\n  `Literature.known_locale_names/0`","title":"Arguments - Literature.Locale.territory_from_locale/1","ref":"Literature.Locale.html#territory_from_locale/1-arguments"},{"type":"function","doc":"* A territory code as an atom","title":"Returns - Literature.Locale.territory_from_locale/1","ref":"Literature.Locale.html#territory_from_locale/1-returns"},{"type":"function","doc":"iex> Literature.Locale.territory_from_locale \"en-US\"\n    :US\n\n    iex> Literature.Locale.territory_from_locale \"en-US-u-rg-GBzzzz\"\n    :GB","title":"Examples - Literature.Locale.territory_from_locale/1","ref":"Literature.Locale.html#territory_from_locale/1-examples"},{"type":"function","doc":"Returns the time zone from a language tag or\nlocale name.","title":"Literature.Locale.timezone_from_locale/1","ref":"Literature.Locale.html#timezone_from_locale/1"},{"type":"function","doc":"* `locale` is any language tag returned by\n  `Literature.Locale.new/1`\n  or a locale name in the list returned by\n  `Literature.known_locale_names/0`","title":"Arguments - Literature.Locale.timezone_from_locale/1","ref":"Literature.Locale.html#timezone_from_locale/1-arguments"},{"type":"function","doc":"* A time zone ID as a string or\n\n* `:error` if no time zone can be determined","title":"Returns - Literature.Locale.timezone_from_locale/1","ref":"Literature.Locale.html#timezone_from_locale/1-returns"},{"type":"function","doc":"iex> Literature.Locale.timezone_from_locale \"en-US-u-tz-ausyd\"\n    \"Australia/Sydney\"","title":"Examples - Literature.Locale.timezone_from_locale/1","ref":"Literature.Locale.html#timezone_from_locale/1-examples"},{"type":"behaviour","doc":"Migrations create the database tables Literature needs.","title":"Literature.Migration","ref":"Literature.Migration.html"},{"type":"behaviour","doc":"To use migrations in your application you'll need to generate an `Ecto.Migration` that wraps\ncalls to `Literature.Migrations`:\n\n```bash\nmix ecto.gen.migration add_literature\n```\n\nOpen the generated migration in your editor and call the `up` and `down` functions on\n`Literature.Migrations`:\n\n```elixir\ndefmodule MyApp.Repo.Migrations.AddLiterature do\n  use Ecto.Migration\n  \n  def up, do: Literature.Migrations.up(version: 1)\n  \n  def down, do: Literature.Migrations.down(version: 1)\nend\n```\n\nThis will run the migrations for your database.\n\nNow, run the migration to create the table:\n\n```bash\nmix ecto.migrate\n```","title":"Usage - Literature.Migration","ref":"Literature.Migration.html#module-usage"},{"type":"function","doc":"","title":"Literature.Migration.down/1","ref":"Literature.Migration.html#down/1"},{"type":"callback","doc":"","title":"Literature.Migration.down/1","ref":"Literature.Migration.html#c:down/1"},{"type":"function","doc":"","title":"Literature.Migration.migrated_version/1","ref":"Literature.Migration.html#migrated_version/1"},{"type":"callback","doc":"","title":"Literature.Migration.migrated_version/1","ref":"Literature.Migration.html#c:migrated_version/1"},{"type":"function","doc":"","title":"Literature.Migration.up/1","ref":"Literature.Migration.html#up/1"},{"type":"callback","doc":"","title":"Literature.Migration.up/1","ref":"Literature.Migration.html#c:up/1"},{"type":"module","doc":"update @current_version if adding new migration","title":"Literature.Migrations.Postgres","ref":"Literature.Migrations.Postgres.html"},{"type":"module","doc":"Beginning tables for Literature","title":"Literature.Migrations.Postgres.V01","ref":"Literature.Migrations.Postgres.V01.html"},{"type":"function","doc":"","title":"Literature.Migrations.Postgres.V01.down/1","ref":"Literature.Migrations.Postgres.V01.html#down/1"},{"type":"function","doc":"","title":"Literature.Migrations.Postgres.V01.up/1","ref":"Literature.Migrations.Postgres.V01.html#up/1"},{"type":"module","doc":"Adds more indexes","title":"Literature.Migrations.Postgres.V02","ref":"Literature.Migrations.Postgres.V02.html"},{"type":"function","doc":"","title":"Literature.Migrations.Postgres.V02.down/1","ref":"Literature.Migrations.Postgres.V02.html#down/1"},{"type":"function","doc":"","title":"Literature.Migrations.Postgres.V02.up/1","ref":"Literature.Migrations.Postgres.V02.html#up/1"},{"type":"module","doc":"Add literature_redirects table","title":"Literature.Migrations.Postgres.V03","ref":"Literature.Migrations.Postgres.V03.html"},{"type":"function","doc":"","title":"Literature.Migrations.Postgres.V03.down/1","ref":"Literature.Migrations.Postgres.V03.html#down/1"},{"type":"function","doc":"","title":"Literature.Migrations.Postgres.V03.up/1","ref":"Literature.Migrations.Postgres.V03.html#up/1"},{"type":"module","doc":"Add language to publications and posts","title":"Literature.Migrations.Postgres.V04","ref":"Literature.Migrations.Postgres.V04.html"},{"type":"function","doc":"","title":"Literature.Migrations.Postgres.V04.down/1","ref":"Literature.Migrations.Postgres.V04.html#down/1"},{"type":"function","doc":"","title":"Literature.Migrations.Postgres.V04.up/1","ref":"Literature.Migrations.Postgres.V04.html#up/1"},{"type":"module","doc":"Add position to literature_tags_posts","title":"Literature.Migrations.Postgres.V05","ref":"Literature.Migrations.Postgres.V05.html"},{"type":"function","doc":"","title":"Literature.Migrations.Postgres.V05.down/1","ref":"Literature.Migrations.Postgres.V05.html#down/1"},{"type":"function","doc":"","title":"Literature.Migrations.Postgres.V05.up/1","ref":"Literature.Migrations.Postgres.V05.html#up/1"},{"type":"module","doc":"Add is_published to literature_posts","title":"Literature.Migrations.Postgres.V06","ref":"Literature.Migrations.Postgres.V06.html"},{"type":"function","doc":"","title":"Literature.Migrations.Postgres.V06.down/1","ref":"Literature.Migrations.Postgres.V06.html#down/1"},{"type":"function","doc":"","title":"Literature.Migrations.Postgres.V06.up/1","ref":"Literature.Migrations.Postgres.V06.html#up/1"},{"type":"module","doc":"Add notes to posts","title":"Literature.Migrations.Postgres.V07","ref":"Literature.Migrations.Postgres.V07.html"},{"type":"function","doc":"","title":"Literature.Migrations.Postgres.V07.down/1","ref":"Literature.Migrations.Postgres.V07.html#down/1"},{"type":"function","doc":"","title":"Literature.Migrations.Postgres.V07.up/1","ref":"Literature.Migrations.Postgres.V07.html#up/1"},{"type":"module","doc":"Add rss fields to publication","title":"Literature.Migrations.Postgres.V08","ref":"Literature.Migrations.Postgres.V08.html"},{"type":"function","doc":"","title":"Literature.Migrations.Postgres.V08.down/1","ref":"Literature.Migrations.Postgres.V08.html#down/1"},{"type":"function","doc":"","title":"Literature.Migrations.Postgres.V08.up/1","ref":"Literature.Migrations.Postgres.V08.html#up/1"},{"type":"module","doc":"Adds more indexes","title":"Literature.Migrations.Postgres.V09","ref":"Literature.Migrations.Postgres.V09.html"},{"type":"function","doc":"","title":"Literature.Migrations.Postgres.V09.down/1","ref":"Literature.Migrations.Postgres.V09.html#down/1"},{"type":"function","doc":"","title":"Literature.Migrations.Postgres.V09.up/1","ref":"Literature.Migrations.Postgres.V09.html#up/1"},{"type":"module","doc":"Adds more indexes","title":"Literature.Migrations.Postgres.V10","ref":"Literature.Migrations.Postgres.V10.html"},{"type":"function","doc":"","title":"Literature.Migrations.Postgres.V10.down/1","ref":"Literature.Migrations.Postgres.V10.html#down/1"},{"type":"function","doc":"","title":"Literature.Migrations.Postgres.V10.up/1","ref":"Literature.Migrations.Postgres.V10.html#up/1"},{"type":"module","doc":"Implements cardinal plural rules for numbers.","title":"Literature.Number.Cardinal","ref":"Literature.Number.Cardinal.html"},{"type":"function","doc":"The locale names for which plural rules are defined.","title":"Literature.Number.Cardinal.available_locale_names/0","ref":"Literature.Number.Cardinal.html#available_locale_names/0"},{"type":"function","doc":"The configured locales for which plural rules are defined.\n\nReturns the intersection of `Literature.known_locale_names/0` and\nthe locales for which Cardinal plural rules are defined.\n\nThere are many `Cldr` locales which don't have their own plural\nrules so this list is the intersection of `Cldr`'s configured\nlocales and those that have rules.","title":"Literature.Number.Cardinal.known_locale_names/0","ref":"Literature.Number.Cardinal.html#known_locale_names/0"},{"type":"function","doc":"Return the plural key for a given number in a given locale\n\nReturns which plural key (`:zero`, `:one`, `:two`, `:few`,\n`:many` or `:other`) a given number fits into within the\ncontext of a given locale.\n\nNote that these key names should not be interpreted\nliterally.  For example, the key returned from\n`Cldr.Number.Ordinal.plural_rule(0, \"en\")` is actually\n`:other`, not `:zero`.\n\nThis key can then be used to format a number, date, time, unit,\nlist or other content in a plural-sensitive way.","title":"Literature.Number.Cardinal.plural_rule/3","ref":"Literature.Number.Cardinal.html#plural_rule/3"},{"type":"function","doc":"* `number` is any `integer`, `float` or `Decimal`\n\n* `locale` is any locale returned by `Cldr.Locale.new!/2` or any\n  `locale_name` returned by `Literature.known_locale_names/0`\n\n* `rounding` is one of `[:down, :up, :ceiling, :floor, :half_even, :half_up, :half_down]`.  The\n  default is `:half_even`.","title":"Arguments - Literature.Number.Cardinal.plural_rule/3","ref":"Literature.Number.Cardinal.html#plural_rule/3-arguments"},{"type":"function","doc":"iex> Literature.Number.Cardinal.plural_rule 0, \"fr\"\n    :one\n\n    iex> Literature.Number.Cardinal.plural_rule 0, \"en\"\n    :other","title":"Examples - Literature.Number.Cardinal.plural_rule/3","ref":"Literature.Number.Cardinal.html#plural_rule/3-examples"},{"type":"function","doc":"Returns all the plural rules defined in CLDR.","title":"Literature.Number.Cardinal.plural_rules/0","ref":"Literature.Number.Cardinal.html#plural_rules/0"},{"type":"function","doc":"Return the plural rules for a locale.","title":"Literature.Number.Cardinal.plural_rules_for/1","ref":"Literature.Number.Cardinal.html#plural_rules_for/1"},{"type":"function","doc":"* `locale` is any locale returned by `Literature.Locale.new!/1` or any\n  `locale_name` returned by `Literature.known_locale_names/0`\n\nThe rules are returned in AST form after parsing.","title":"Arguments - Literature.Number.Cardinal.plural_rules_for/1","ref":"Literature.Number.Cardinal.html#plural_rules_for/1-arguments"},{"type":"function","doc":"Pluralize a number using cardinal plural rules\nand a substitution map.","title":"Literature.Number.Cardinal.pluralize/3","ref":"Literature.Number.Cardinal.html#pluralize/3"},{"type":"function","doc":"* `number` is an integer, float or Decimal\n\n* `locale` is any locale returned by `Literature.Locale.new!/1` or any\n  `locale_name` returned by `Literature.known_locale_names/0`\n\n* `substitutions` is a map that maps plural keys to a string.\n  The valid substitution keys are `:zero`, `:one`, `:two`,\n  `:few`, `:many` and `:other`.\n\nSee also `Literature.Number.Cardinal.Cardinal.plural_rule/3`.","title":"Arguments - Literature.Number.Cardinal.pluralize/3","ref":"Literature.Number.Cardinal.html#pluralize/3-arguments"},{"type":"function","doc":"iex> Literature.Number.Cardinal.pluralize 1, \"en\", %{one: \"one\"}\n    \"one\"\n\n    iex> Literature.Number.Cardinal.pluralize 2, \"en\", %{one: \"one\"}\n    nil\n\n    iex> Literature.Number.Cardinal.pluralize 2, \"en\", %{one: \"one\", two: \"two\", other: \"other\"}\n    \"other\"\n\n    iex> Literature.Number.Cardinal.pluralize 22, \"en\", %{one: \"one\", two: \"two\", other: \"other\"}\n    \"other\"\n\n    iex> Literature.Number.Cardinal.pluralize Decimal.new(1), \"en\", %{one: \"one\"}\n    \"one\"\n\n    iex> Literature.Number.Cardinal.pluralize Decimal.new(2), \"en\", %{one: \"one\"}\n    nil\n\n    iex> Literature.Number.Cardinal.pluralize Decimal.new(2), \"en\", %{one: \"one\", two: \"two\"}\n    nil\n\n    iex> Literature.Number.Cardinal.pluralize 1..10, \"ar\", %{one: \"one\", few: \"few\", other: \"other\"}\n    \"few\"\n\n    iex> Literature.Number.Cardinal.pluralize 1..10, \"en\", %{one: \"one\", few: \"few\", other: \"other\"}\n    \"other\"","title":"Examples - Literature.Number.Cardinal.pluralize/3","ref":"Literature.Number.Cardinal.html#pluralize/3-examples"},{"type":"module","doc":"Implements ordinal plural rules for numbers.","title":"Literature.Number.Ordinal","ref":"Literature.Number.Ordinal.html"},{"type":"function","doc":"The locale names for which plural rules are defined.","title":"Literature.Number.Ordinal.available_locale_names/0","ref":"Literature.Number.Ordinal.html#available_locale_names/0"},{"type":"function","doc":"The configured locales for which plural rules are defined.\n\nReturns the intersection of `Literature.known_locale_names/0` and\nthe locales for which Ordinal plural rules are defined.\n\nThere are many `Cldr` locales which don't have their own plural\nrules so this list is the intersection of `Cldr`'s configured\nlocales and those that have rules.","title":"Literature.Number.Ordinal.known_locale_names/0","ref":"Literature.Number.Ordinal.html#known_locale_names/0"},{"type":"function","doc":"Return the plural key for a given number in a given locale\n\nReturns which plural key (`:zero`, `:one`, `:two`, `:few`,\n`:many` or `:other`) a given number fits into within the\ncontext of a given locale.\n\nNote that these key names should not be interpreted\nliterally.  For example, the key returned from\n`Cldr.Number.Ordinal.plural_rule(0, \"en\")` is actually\n`:other`, not `:zero`.\n\nThis key can then be used to format a number, date, time, unit,\nlist or other content in a plural-sensitive way.","title":"Literature.Number.Ordinal.plural_rule/3","ref":"Literature.Number.Ordinal.html#plural_rule/3"},{"type":"function","doc":"* `number` is any `integer`, `float` or `Decimal`\n\n* `locale` is any locale returned by `Cldr.Locale.new!/2` or any\n  `locale_name` returned by `Literature.known_locale_names/0`\n\n* `rounding` is one of `[:down, :up, :ceiling, :floor, :half_even, :half_up, :half_down]`.  The\n  default is `:half_even`.","title":"Arguments - Literature.Number.Ordinal.plural_rule/3","ref":"Literature.Number.Ordinal.html#plural_rule/3-arguments"},{"type":"function","doc":"iex> Literature.Number.Ordinal.plural_rule 0, \"fr\"\n    :other\n\n    iex> Literature.Number.Ordinal.plural_rule 1, \"en\"\n    :one","title":"Examples - Literature.Number.Ordinal.plural_rule/3","ref":"Literature.Number.Ordinal.html#plural_rule/3-examples"},{"type":"function","doc":"Returns all the plural rules defined in CLDR.","title":"Literature.Number.Ordinal.plural_rules/0","ref":"Literature.Number.Ordinal.html#plural_rules/0"},{"type":"function","doc":"Return the plural rules for a locale.","title":"Literature.Number.Ordinal.plural_rules_for/1","ref":"Literature.Number.Ordinal.html#plural_rules_for/1"},{"type":"function","doc":"* `locale` is any locale returned by `Literature.Locale.new!/1` or any\n  `locale_name` returned by `Literature.known_locale_names/0`\n\nThe rules are returned in AST form after parsing.","title":"Arguments - Literature.Number.Ordinal.plural_rules_for/1","ref":"Literature.Number.Ordinal.html#plural_rules_for/1-arguments"},{"type":"function","doc":"Pluralize a number using ordinal plural rules\nand a substitution map.","title":"Literature.Number.Ordinal.pluralize/3","ref":"Literature.Number.Ordinal.html#pluralize/3"},{"type":"function","doc":"* `number` is an integer, float or Decimal or a `Range.t{}`.  When a range, The\n  is that in any usage, the start value is strictly less than the end value,\n  and that no values are negative. Results for any cases that do not meet\n  these criteria are undefined.\n\n* `locale` is any locale returned by `Literature.Locale.new!/1` or any\n  `locale_name` returned by `Literature.known_locale_names/0`\n\n* `substitutions` is a map that maps plural keys to a string.\n  The valid substitution keys are `:zero`, `:one`, `:two`,\n  `:few`, `:many` and `:other`.\n\nSee also `Literature.Number.Ordinal.Ordinal.plural_rule/3`.","title":"Arguments - Literature.Number.Ordinal.pluralize/3","ref":"Literature.Number.Ordinal.html#pluralize/3-arguments"},{"type":"function","doc":"iex> Literature.Number.Ordinal.pluralize 1, :en, %{one: \"one\"}\n    \"one\"\n\n    iex> Literature.Number.Ordinal.pluralize 2, :en, %{one: \"one\"}\n    nil\n\n    iex> Literature.Number.Ordinal.pluralize 2, :en, %{one: \"one\", two: \"two\"}\n    \"two\"\n\n    iex> Literature.Number.Ordinal.pluralize 22, :en, %{one: \"one\", two: \"two\", other: \"other\"}\n    \"two\"\n\n    iex> Literature.Number.Ordinal.pluralize Decimal.new(1), :en, %{one: \"one\"}\n    \"one\"\n\n    iex> Literature.Number.Ordinal.pluralize Decimal.new(2), :en, %{one: \"one\"}\n    nil\n\n    iex> Literature.Number.Ordinal.pluralize Decimal.new(2), :en, %{one: \"one\", two: \"two\"}\n    \"two\"\n\n    iex> Literature.Number.Ordinal.pluralize 1..10, \"ar\", %{one: \"one\", few: \"few\", other: \"other\"}\n    \"other\"\n\n    iex> Literature.Number.Ordinal.pluralize 1..10, \"en\", %{one: \"one\", few: \"few\", other: \"other\"}\n    \"other\"","title":"Examples - Literature.Number.Ordinal.pluralize/3","ref":"Literature.Number.Ordinal.html#pluralize/3-examples"},{"type":"module","doc":"Implements plural rules for ranges","title":"Literature.Number.PluralRule.Range","ref":"Literature.Number.PluralRule.Range.html"},{"type":"function","doc":"Returns a final plural type for a start-of-range plural\ntype, an end-of-range plural type and a locale.","title":"Literature.Number.PluralRule.Range.plural_rule/3","ref":"Literature.Number.PluralRule.Range.html#plural_rule/3"},{"type":"function","doc":"* `first` is a plural type for the start of a range\n\n* `last` is a plural type for the end of a range\n\n* `locale` is any `Cldr.LanguageTag.t` or a language name\n  (not locale name)","title":"Arguments - Literature.Number.PluralRule.Range.plural_rule/3","ref":"Literature.Number.PluralRule.Range.html#plural_rule/3-arguments"},{"type":"function","doc":"iex> Literature.Number.PluralRule.Range.plural_rule :other, :few, \"ar\"\n    :few","title":"Example - Literature.Number.PluralRule.Range.plural_rule/3","ref":"Literature.Number.PluralRule.Range.html#plural_rule/3-example"},{"type":"module","doc":"Pagination API","title":"Literature.Pagination","ref":"Literature.Pagination.html"},{"type":"function","doc":"","title":"Literature.Pagination.paginate/3","ref":"Literature.Pagination.html#paginate/3"},{"type":"function","doc":"","title":"Literature.Pagination.to_valid_repo_opts/1","ref":"Literature.Pagination.html#to_valid_repo_opts/1"},{"type":"module","doc":"Struct for pages metadata","title":"Literature.Pagination.Page","ref":"Literature.Pagination.Page.html"},{"type":"type","doc":"","title":"Literature.Pagination.Page.pagination_params/0","ref":"Literature.Pagination.Page.html#t:pagination_params/0"},{"type":"type","doc":"","title":"Literature.Pagination.Page.t/0","ref":"Literature.Pagination.Page.html#t:t/0"},{"type":"type","doc":"","title":"Literature.Pagination.Page.t/1","ref":"Literature.Pagination.Page.html#t:t/1"},{"type":"protocol","doc":"The `Literature.Pagination.Paginater` protocol should be implemented for any type that requires pagination.","title":"Literature.Pagination.Paginater","ref":"Literature.Pagination.Paginater.html"},{"type":"function","doc":"The paginate function will be invoked with the item to paginate along with an option. It is expected to return a `Literature.Pagination.Page`.","title":"Literature.Pagination.Paginater.paginate/3","ref":"Literature.Pagination.Paginater.html#paginate/3"},{"type":"type","doc":"All the types that implement this protocol.","title":"Literature.Pagination.Paginater.t/0","ref":"Literature.Pagination.Paginater.html#t:t/0"},{"type":"module","doc":"This plug is responsible for maybe redirecting requests from one path\nto another inside a publication.","title":"Literature.Plugs.Redirect","ref":"Literature.Plugs.Redirect.html"},{"type":"function","doc":"","title":"Literature.Plugs.Redirect.call/2","ref":"Literature.Plugs.Redirect.html#call/2"},{"type":"function","doc":"","title":"Literature.Plugs.Redirect.init/1","ref":"Literature.Plugs.Redirect.html#init/1"},{"type":"module","doc":"Wrappers around `Ecto.Repo` callbacks.\n\nThese functions should be used when working with an Ecto repo. These functions\nwill resolve the correct repo instance, and set the schema prefix and the log level, according\nto the Literature configuration.","title":"Literature.Repo","ref":"Literature.Repo.html"},{"type":"function","doc":"Wraps `c:Ecto.Repo.all/2`.","title":"Literature.Repo.all/2","ref":"Literature.Repo.html#all/2"},{"type":"function","doc":"Wraps `c:Ecto.Repo.delete/2`.","title":"Literature.Repo.delete/2","ref":"Literature.Repo.html#delete/2"},{"type":"function","doc":"Wraps `c:Ecto.Repo.get/2`.","title":"Literature.Repo.get/2","ref":"Literature.Repo.html#get/2"},{"type":"function","doc":"Wraps `c:Ecto.Repo.get_by/2`.","title":"Literature.Repo.get_by/2","ref":"Literature.Repo.html#get_by/2"},{"type":"function","doc":"Wraps `c:Ecto.Repo.insert/2`.","title":"Literature.Repo.insert/2","ref":"Literature.Repo.html#insert/2"},{"type":"function","doc":"Wraps `c:Ecto.Repo.insert_all/3`.","title":"Literature.Repo.insert_all/3","ref":"Literature.Repo.html#insert_all/3"},{"type":"function","doc":"Wraps `c:Ecto.Repo.paginate/2`.","title":"Literature.Repo.paginate/2","ref":"Literature.Repo.html#paginate/2"},{"type":"function","doc":"Wraps `c:Ecto.Repo.preload/2`.","title":"Literature.Repo.preload/3","ref":"Literature.Repo.html#preload/3"},{"type":"function","doc":"Wraps `c:Ecto.Repo.update/2`.","title":"Literature.Repo.update/2","ref":"Literature.Repo.html#update/2"},{"type":"function","doc":"Wraps `c:Ecto.Repo.update_all/3`.","title":"Literature.Repo.update_all/3","ref":"Literature.Repo.html#update_all/3"},{"type":"module","doc":"Provides LiveView routing for literature.","title":"Literature.Router","ref":"Literature.Router.html"},{"type":"macro","doc":"","title":"Literature.Router.custom_show_author_route/2","ref":"Literature.Router.html#custom_show_author_route/2"},{"type":"macro","doc":"","title":"Literature.Router.custom_show_tag_route/2","ref":"Literature.Router.html#custom_show_tag_route/2"},{"type":"macro","doc":"Defines a Literature route.\n\nIt requires a path where to mount the public page at and allows options to customize routing.","title":"Literature.Router.literature/2","ref":"Literature.Router.html#literature/2"},{"type":"macro","doc":"Mount a `blog` at the path \"/blog\":\n\n    defmodule MyAppWeb.Router do\n      use Phoenix.Router\n      use Literature.Router\n\n      scope \"/\", MyAppWeb do\n        pipe_through [:browser]\n\n        literature \"/blog\"\n      end\n    end","title":"Examples - Literature.Router.literature/2","ref":"Literature.Router.html#literature/2-examples"},{"type":"macro","doc":"Defines a Literature API route.","title":"Literature.Router.literature_api/2","ref":"Literature.Router.html#literature_api/2"},{"type":"macro","doc":"defmodule MyAppWeb.Router do\n      use Phoenix.Router\n      use Literature.Router\n\n      literature_api \"/api\"\n    end","title":"Examples - Literature.Router.literature_api/2","ref":"Literature.Router.html#literature_api/2-examples"},{"type":"macro","doc":"Defines routes for Literature static assets.\n\nStatic assets should not be CSRF protected. So they need to be mounted in your\nrouter in a different pipeline.\n\nIt can take the `path` the literature assets will be mounted at.","title":"Literature.Router.literature_assets/1","ref":"Literature.Router.html#literature_assets/1"},{"type":"macro","doc":"```elixir\n# lib/my_app_web/router.ex\nuse MyAppWeb, :router\nimport Literature.Router\n...\n\nscope \"/\" do\n  literature_assets(\"/\")\nend\n```","title":"Usage - Literature.Router.literature_assets/1","ref":"Literature.Router.html#literature_assets/1-usage"},{"type":"macro","doc":"Defines a Literature dashboard route.\n\nIt requires a path where to mount the dashboard at and allows options to customize routing.","title":"Literature.Router.literature_dashboard/2","ref":"Literature.Router.html#literature_dashboard/2"},{"type":"macro","doc":"Mount an `literature` dashboard at the path \"/literature\":\n\n    defmodule MyAppWeb.Router do\n      use Phoenix.Router\n      use Literature.Router\n\n      scope \"/\", MyAppWeb do\n        pipe_through [:browser]\n\n        literature_dashboard \"/literature\"\n      end\n    end","title":"Examples - Literature.Router.literature_dashboard/2","ref":"Literature.Router.html#literature_dashboard/2-examples"},{"type":"module","doc":"Literature Uploaders","title":"Literature.Uploaders","ref":"Literature.Uploaders.html"},{"type":"function","doc":"","title":"Literature.Uploaders.acl/2","ref":"Literature.Uploaders.html#acl/2"},{"type":"function","doc":"","title":"Literature.Uploaders.asset_host/0","ref":"Literature.Uploaders.html#asset_host/0"},{"type":"function","doc":"","title":"Literature.Uploaders.async/0","ref":"Literature.Uploaders.html#async/0"},{"type":"function","doc":"","title":"Literature.Uploaders.bucket/0","ref":"Literature.Uploaders.html#bucket/0"},{"type":"function","doc":"","title":"Literature.Uploaders.bucket/1","ref":"Literature.Uploaders.html#bucket/1"},{"type":"function","doc":"","title":"Literature.Uploaders.default_url/1","ref":"Literature.Uploaders.html#default_url/1"},{"type":"function","doc":"","title":"Literature.Uploaders.default_url/2","ref":"Literature.Uploaders.html#default_url/2"},{"type":"function","doc":"","title":"Literature.Uploaders.delete/1","ref":"Literature.Uploaders.html#delete/1"},{"type":"function","doc":"","title":"Literature.Uploaders.filename/2","ref":"Literature.Uploaders.html#filename/2"},{"type":"function","doc":"","title":"Literature.Uploaders.remote_file_headers/1","ref":"Literature.Uploaders.html#remote_file_headers/1"},{"type":"function","doc":"","title":"Literature.Uploaders.s3_object_headers/2","ref":"Literature.Uploaders.html#s3_object_headers/2"},{"type":"function","doc":"","title":"Literature.Uploaders.storage_dir/2","ref":"Literature.Uploaders.html#storage_dir/2"},{"type":"function","doc":"","title":"Literature.Uploaders.storage_dir_prefix/0","ref":"Literature.Uploaders.html#storage_dir_prefix/0"},{"type":"function","doc":"","title":"Literature.Uploaders.store/1","ref":"Literature.Uploaders.html#store/1"},{"type":"function","doc":"","title":"Literature.Uploaders.transform/2","ref":"Literature.Uploaders.html#transform/2"},{"type":"function","doc":"","title":"Literature.Uploaders.url/1","ref":"Literature.Uploaders.html#url/1"},{"type":"function","doc":"","title":"Literature.Uploaders.url/2","ref":"Literature.Uploaders.html#url/2"},{"type":"function","doc":"","title":"Literature.Uploaders.url/3","ref":"Literature.Uploaders.html#url/3"},{"type":"function","doc":"","title":"Literature.Uploaders.urls/2","ref":"Literature.Uploaders.html#urls/2"},{"type":"function","doc":"","title":"Literature.Uploaders.validate/1","ref":"Literature.Uploaders.html#validate/1"},{"type":"module","doc":"Literature Uploaders","title":"Literature.Uploaders.DifferentSizes","ref":"Literature.Uploaders.DifferentSizes.html"},{"type":"function","doc":"","title":"Literature.Uploaders.DifferentSizes.acl/2","ref":"Literature.Uploaders.DifferentSizes.html#acl/2"},{"type":"function","doc":"","title":"Literature.Uploaders.DifferentSizes.asset_host/0","ref":"Literature.Uploaders.DifferentSizes.html#asset_host/0"},{"type":"function","doc":"","title":"Literature.Uploaders.DifferentSizes.async/0","ref":"Literature.Uploaders.DifferentSizes.html#async/0"},{"type":"function","doc":"","title":"Literature.Uploaders.DifferentSizes.bucket/0","ref":"Literature.Uploaders.DifferentSizes.html#bucket/0"},{"type":"function","doc":"","title":"Literature.Uploaders.DifferentSizes.bucket/1","ref":"Literature.Uploaders.DifferentSizes.html#bucket/1"},{"type":"function","doc":"","title":"Literature.Uploaders.DifferentSizes.default_url/1","ref":"Literature.Uploaders.DifferentSizes.html#default_url/1"},{"type":"function","doc":"","title":"Literature.Uploaders.DifferentSizes.default_url/2","ref":"Literature.Uploaders.DifferentSizes.html#default_url/2"},{"type":"function","doc":"","title":"Literature.Uploaders.DifferentSizes.delete/1","ref":"Literature.Uploaders.DifferentSizes.html#delete/1"},{"type":"function","doc":"","title":"Literature.Uploaders.DifferentSizes.filename/2","ref":"Literature.Uploaders.DifferentSizes.html#filename/2"},{"type":"function","doc":"","title":"Literature.Uploaders.DifferentSizes.remote_file_headers/1","ref":"Literature.Uploaders.DifferentSizes.html#remote_file_headers/1"},{"type":"function","doc":"","title":"Literature.Uploaders.DifferentSizes.s3_object_headers/2","ref":"Literature.Uploaders.DifferentSizes.html#s3_object_headers/2"},{"type":"function","doc":"","title":"Literature.Uploaders.DifferentSizes.storage_dir/2","ref":"Literature.Uploaders.DifferentSizes.html#storage_dir/2"},{"type":"function","doc":"","title":"Literature.Uploaders.DifferentSizes.storage_dir_prefix/0","ref":"Literature.Uploaders.DifferentSizes.html#storage_dir_prefix/0"},{"type":"function","doc":"","title":"Literature.Uploaders.DifferentSizes.store/1","ref":"Literature.Uploaders.DifferentSizes.html#store/1"},{"type":"function","doc":"","title":"Literature.Uploaders.DifferentSizes.store_different_sizes/2","ref":"Literature.Uploaders.DifferentSizes.html#store_different_sizes/2"},{"type":"function","doc":"","title":"Literature.Uploaders.DifferentSizes.transform/2","ref":"Literature.Uploaders.DifferentSizes.html#transform/2"},{"type":"function","doc":"","title":"Literature.Uploaders.DifferentSizes.url/1","ref":"Literature.Uploaders.DifferentSizes.html#url/1"},{"type":"function","doc":"","title":"Literature.Uploaders.DifferentSizes.url/2","ref":"Literature.Uploaders.DifferentSizes.html#url/2"},{"type":"function","doc":"","title":"Literature.Uploaders.DifferentSizes.url/3","ref":"Literature.Uploaders.DifferentSizes.html#url/3"},{"type":"function","doc":"","title":"Literature.Uploaders.DifferentSizes.urls/2","ref":"Literature.Uploaders.DifferentSizes.html#urls/2"},{"type":"function","doc":"","title":"Literature.Uploaders.DifferentSizes.validate/1","ref":"Literature.Uploaders.DifferentSizes.html#validate/1"},{"type":"module","doc":"","title":"Literature.Uploaders.DifferentSizes.Type","ref":"Literature.Uploaders.DifferentSizes.Type.html"},{"type":"function","doc":"Callback implementation for  Ecto.Type.cast/1 .","title":"Literature.Uploaders.DifferentSizes.Type.cast/1","ref":"Literature.Uploaders.DifferentSizes.Type.html#cast/1"},{"type":"function","doc":"Callback implementation for  Ecto.Type.dump/1 .","title":"Literature.Uploaders.DifferentSizes.Type.dump/1","ref":"Literature.Uploaders.DifferentSizes.Type.html#dump/1"},{"type":"function","doc":"Callback implementation for  Ecto.Type.embed_as/1 .","title":"Literature.Uploaders.DifferentSizes.Type.embed_as/1","ref":"Literature.Uploaders.DifferentSizes.Type.html#embed_as/1"},{"type":"function","doc":"Callback implementation for  Ecto.Type.equal?/2 .","title":"Literature.Uploaders.DifferentSizes.Type.equal?/2","ref":"Literature.Uploaders.DifferentSizes.Type.html#equal?/2"},{"type":"function","doc":"Callback implementation for  Ecto.Type.load/1 .","title":"Literature.Uploaders.DifferentSizes.Type.load/1","ref":"Literature.Uploaders.DifferentSizes.Type.html#load/1"},{"type":"function","doc":"Callback implementation for  Ecto.Type.type/0 .","title":"Literature.Uploaders.DifferentSizes.Type.type/0","ref":"Literature.Uploaders.DifferentSizes.Type.html#type/0"},{"type":"module","doc":"Literature Profile Image Uploader","title":"Literature.Uploaders.ProfileImage","ref":"Literature.Uploaders.ProfileImage.html"},{"type":"function","doc":"","title":"Literature.Uploaders.ProfileImage.acl/2","ref":"Literature.Uploaders.ProfileImage.html#acl/2"},{"type":"function","doc":"","title":"Literature.Uploaders.ProfileImage.asset_host/0","ref":"Literature.Uploaders.ProfileImage.html#asset_host/0"},{"type":"function","doc":"","title":"Literature.Uploaders.ProfileImage.async/0","ref":"Literature.Uploaders.ProfileImage.html#async/0"},{"type":"function","doc":"","title":"Literature.Uploaders.ProfileImage.bucket/0","ref":"Literature.Uploaders.ProfileImage.html#bucket/0"},{"type":"function","doc":"","title":"Literature.Uploaders.ProfileImage.bucket/1","ref":"Literature.Uploaders.ProfileImage.html#bucket/1"},{"type":"function","doc":"","title":"Literature.Uploaders.ProfileImage.default_url/1","ref":"Literature.Uploaders.ProfileImage.html#default_url/1"},{"type":"function","doc":"","title":"Literature.Uploaders.ProfileImage.default_url/2","ref":"Literature.Uploaders.ProfileImage.html#default_url/2"},{"type":"function","doc":"","title":"Literature.Uploaders.ProfileImage.delete/1","ref":"Literature.Uploaders.ProfileImage.html#delete/1"},{"type":"function","doc":"","title":"Literature.Uploaders.ProfileImage.filename/2","ref":"Literature.Uploaders.ProfileImage.html#filename/2"},{"type":"function","doc":"","title":"Literature.Uploaders.ProfileImage.remote_file_headers/1","ref":"Literature.Uploaders.ProfileImage.html#remote_file_headers/1"},{"type":"function","doc":"","title":"Literature.Uploaders.ProfileImage.s3_object_headers/2","ref":"Literature.Uploaders.ProfileImage.html#s3_object_headers/2"},{"type":"function","doc":"","title":"Literature.Uploaders.ProfileImage.storage_dir/2","ref":"Literature.Uploaders.ProfileImage.html#storage_dir/2"},{"type":"function","doc":"","title":"Literature.Uploaders.ProfileImage.storage_dir_prefix/0","ref":"Literature.Uploaders.ProfileImage.html#storage_dir_prefix/0"},{"type":"function","doc":"","title":"Literature.Uploaders.ProfileImage.store/1","ref":"Literature.Uploaders.ProfileImage.html#store/1"},{"type":"function","doc":"","title":"Literature.Uploaders.ProfileImage.transform/2","ref":"Literature.Uploaders.ProfileImage.html#transform/2"},{"type":"function","doc":"","title":"Literature.Uploaders.ProfileImage.url/1","ref":"Literature.Uploaders.ProfileImage.html#url/1"},{"type":"function","doc":"","title":"Literature.Uploaders.ProfileImage.url/2","ref":"Literature.Uploaders.ProfileImage.html#url/2"},{"type":"function","doc":"","title":"Literature.Uploaders.ProfileImage.url/3","ref":"Literature.Uploaders.ProfileImage.html#url/3"},{"type":"function","doc":"","title":"Literature.Uploaders.ProfileImage.urls/2","ref":"Literature.Uploaders.ProfileImage.html#urls/2"},{"type":"function","doc":"","title":"Literature.Uploaders.ProfileImage.validate/1","ref":"Literature.Uploaders.ProfileImage.html#validate/1"},{"type":"module","doc":"","title":"Literature.Uploaders.ProfileImage.Type","ref":"Literature.Uploaders.ProfileImage.Type.html"},{"type":"function","doc":"Callback implementation for  Ecto.Type.cast/1 .","title":"Literature.Uploaders.ProfileImage.Type.cast/1","ref":"Literature.Uploaders.ProfileImage.Type.html#cast/1"},{"type":"function","doc":"Callback implementation for  Ecto.Type.dump/1 .","title":"Literature.Uploaders.ProfileImage.Type.dump/1","ref":"Literature.Uploaders.ProfileImage.Type.html#dump/1"},{"type":"function","doc":"Callback implementation for  Ecto.Type.embed_as/1 .","title":"Literature.Uploaders.ProfileImage.Type.embed_as/1","ref":"Literature.Uploaders.ProfileImage.Type.html#embed_as/1"},{"type":"function","doc":"Callback implementation for  Ecto.Type.equal?/2 .","title":"Literature.Uploaders.ProfileImage.Type.equal?/2","ref":"Literature.Uploaders.ProfileImage.Type.html#equal?/2"},{"type":"function","doc":"Callback implementation for  Ecto.Type.load/1 .","title":"Literature.Uploaders.ProfileImage.Type.load/1","ref":"Literature.Uploaders.ProfileImage.Type.html#load/1"},{"type":"function","doc":"Callback implementation for  Ecto.Type.type/0 .","title":"Literature.Uploaders.ProfileImage.Type.type/0","ref":"Literature.Uploaders.ProfileImage.Type.html#type/0"},{"type":"module","doc":"","title":"Literature.Uploaders.Type","ref":"Literature.Uploaders.Type.html"},{"type":"function","doc":"Callback implementation for  Ecto.Type.cast/1 .","title":"Literature.Uploaders.Type.cast/1","ref":"Literature.Uploaders.Type.html#cast/1"},{"type":"function","doc":"Callback implementation for  Ecto.Type.dump/1 .","title":"Literature.Uploaders.Type.dump/1","ref":"Literature.Uploaders.Type.html#dump/1"},{"type":"function","doc":"Callback implementation for  Ecto.Type.embed_as/1 .","title":"Literature.Uploaders.Type.embed_as/1","ref":"Literature.Uploaders.Type.html#embed_as/1"},{"type":"function","doc":"Callback implementation for  Ecto.Type.equal?/2 .","title":"Literature.Uploaders.Type.equal?/2","ref":"Literature.Uploaders.Type.html#equal?/2"},{"type":"function","doc":"Callback implementation for  Ecto.Type.load/1 .","title":"Literature.Uploaders.Type.load/1","ref":"Literature.Uploaders.Type.html#load/1"},{"type":"function","doc":"Callback implementation for  Ecto.Type.type/0 .","title":"Literature.Uploaders.Type.type/0","ref":"Literature.Uploaders.Type.html#type/0"},{"type":"module","doc":"pool boy worker that handles image proccessing and stores it in temp file","title":"Literature.Workers.DownloadWorker","ref":"Literature.Workers.DownloadWorker.html"},{"type":"function","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","title":"Literature.Workers.DownloadWorker.child_spec/1","ref":"Literature.Workers.DownloadWorker.html#child_spec/1"},{"type":"function","doc":"Callback implementation for  GenServer.init/1 .","title":"Literature.Workers.DownloadWorker.init/1","ref":"Literature.Workers.DownloadWorker.html#init/1"},{"type":"function","doc":"","title":"Literature.Workers.DownloadWorker.start_link/1","ref":"Literature.Workers.DownloadWorker.html#start_link/1"},{"type":"exception","doc":"Raised when a page is not found.","title":"Literature.PageNotFound","ref":"Literature.PageNotFound.html"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.2"}}